<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

include_once('functions.php');                                                  // include plugin subfunctions

require "./plugins/gallery_merge/lang/english.php";
if ($CONFIG['lang'] != 'english' && file_exists("./plugins/gallery_merge/lang/{$CONFIG['lang']}.php")) {
    require ("./plugins/gallery_merge/lang/{$CONFIG['lang']}.php");
}

// Define plugin actions here
$thisplugin->add_action('plugin_install','gallery_merge_install');              // install script
$thisplugin->add_action('plugin_cleanup','gallery_merge_cleanup');              // pre-uninstall script
$thisplugin->add_action('plugin_uninstall','gallery_merge_uninstall');          // uninstall script
$thisplugin->add_action('page_start','gallery_merge_admin_button');             // add admin button

// Define plugin filters here
//$thisplugin->add_filter('admin_menu','gallery_merge_config_button');            // admin menu intercept to add button to menu
$thisplugin->add_filter('javascript_includes','gallery_merge_java_scripts');    // javascript include intercept to add our scripts

// Define the plugin's functions here
function gallery_merge_install() {
    global $CONFIG;
    $superCage = Inspekt::makeSuperCage();
    $script_filename = $superCage->env->getRaw('SCRIPT_FILENAME');
    $default_filepath = str_replace('/pluginmgr.php', '', $script_filename);
    $default_album_filepath = $default_filepath.'/'.substr($CONFIG['fullpath'], 0, strlen($CONFIG['fullpath']) - 1);
    $default_perms = substr(sprintf('%o', fileperms($default_album_filepath)), -4);
    // Add the config options for the plugin                                max length:   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_version', '1.0')");
    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET `value` = '1.0' WHERE `name` = 'plugin_gallery_merge_version'");  // update version if re-install
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_config_link', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_hide_buttons', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_local', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_filepath', '$default_filepath')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_dbserver', 'host:port')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_dbuser', '')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_dbpass', '')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_dbname', '')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_source_table_prefix', 'cpg_')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_remove_subfolder', '')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_add_subfolder', '')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_merge_categories', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_merge_albums', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_folder_permissions', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_folder_perm_value', '$default_perms')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_file_permissions', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_file_perm_value', '$default_perms')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_copy_languages', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_copy_plugins', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_copy_themes', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_replace_files', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_checkpoint_freq', '1000')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_checkpoint_quiesce', '10000')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_chkpt_quiesce_files', '30000')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_message_level', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_debug', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_pictures_process', '1')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_config_update', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_db_start', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_db_end', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_db_warn', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_db_start', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_db_end', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_dbbko_start', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_dbbko_end', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_dbbko_start', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_dbbko_end', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_files_start', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_files_end', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_files_start', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_files_end', '0000-00-00 00:00:00')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_sim_chkpttext', '0000-00-00 00:00:00 Checkpoint Data')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_exec_chkpttext', '0000-00-00 00:00:00 Checkpoint Data')");
    // non-displayed and override fields and descriptions
    //* backout_prefix - set prefix to add to backout tables (following cpg prefix and before timestamp) - shorten if any table names exceed 64 characters
    //* do not change if you have backouts already created that you wish to use... (or run those backouts first - or rename tables manually to match new value)
    //* default value of 'galery_merge_bk_' ('plugin_' omitted to shorten name - some tables and prefix combinations exceeded MySQL 64 character limit)
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_backout_prefix', 'gallery_merge_bk_')");
    //* ts_emer_backout - when populated, enables an emergency backout button to backout to the indicated execution timestamp. Only existance of backup files will be validated.
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_ts_emer_backout', '0000-00-00 00:00:00')");
    //* sim_output - when set to 1, output from simulation runs will be written to files as executions are... allows easy capture of output.
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gallery_merge_sim_output', '0')");
    // create restart table
    cpg_db_query("CREATE TABLE IF NOT EXISTS `{$CONFIG['TABLE_PREFIX']}plugin_gallery_merge_restart_data` (
                    `id` int(11) NOT NULL AUTO_INCREMENT, `timestamp` timestamp NOT NULL, `text` varchar(255) NOT NULL, `data` longblob NULL,
                    PRIMARY KEY (`id`), KEY `timestamp` (`timestamp`) ) ENGINE=MyISAM;");
    return true;
}


function gallery_merge_admin_button() {
//example from minicms_add_admin_button" href = 'index.php?file=minicms/cms_admin', $title = $lang_minicms['admin_title'], $target = '', $link = $lang_minicms['admin_title']);
    global $template_gallery_admin_menu;
    global $lang_plugin_gallery_merge, $CONFIG;
    if ((GALLERY_ADMIN_MODE) && ($CONFIG['plugin_gallery_merge_config_link'] == 1)) {
      // get language files
      $gallery_merge_admin_button = TRUE;
      require "./plugins/gallery_merge/lang/english.php";
      if ($CONFIG['lang'] != 'english' && file_exists("./plugins/gallery_merge/lang/{$CONFIG['lang']}.php")) {
        require "./plugins/gallery_merge/lang/{$CONFIG['lang']}.php";
      }

      // insert button under 'update database' in 'config' menu..
      // see theme.php Section <<<$template_gallery_admin_menu>>> for correct array keys to replace for the desired location
      $new_template=$template_gallery_admin_menu;
      $button=template_extract_block($new_template,'update_database');
      $params = array(
        'update.php' => 'index.php?file=gallery_merge/admin&action=configure',
        '{UPDATE_DATABASE_TITLE}' => $lang_plugin_gallery_merge['adminbutton'],
        'target="cpg_documentation"' => '',
        '{UPDATE_DATABASE_LNK}' => $lang_plugin_gallery_merge['adminbutton'],
        '{UPDATE_DATABASE_ICO}' => cpg_fetch_icon('download', 1),
      );
      $new_button="<!-- BEGIN $link -->".template_eval($button,$params)."<!-- END $link -->\n";
      template_extract_block($template_gallery_admin_menu,'update_database',"<!-- BEGIN update_database -->" . $button . "<!-- END update_database -->\n" . $new_button);
    }
}


function gallery_merge_java_scripts($includes){
    if (!in_array('js/admin.js', $includes)) {
      $includes[] = 'js/admin.js';
    }
    $includes[] = 'plugins/gallery_merge/js/script.js';
    return $includes;
}


function gallery_merge_cleanup($action) {
    global $CONFIG, $lang_plugin_gallery_merge, $lang_common;
    // Initialize language and icons
    require_once './plugins/gallery_merge/functions.php';
    // get language files
    require "./plugins/gallery_merge/lang/english.php";
    if ($CONFIG['lang'] != 'english' && file_exists("./plugins/gallery_merge/lang/{$CONFIG['lang']}.php")) {
      require "./plugins/gallery_merge/lang/{$CONFIG['lang']}.php";
    }
    $superCage = Inspekt::makeSuperCage();
    $cleanup = $superCage->server->getEscaped('REQUEST_URI');
    if ($action===1) {
      // prompt to see what we should retain during uninstall...
      // defaults chosen based on current status
      $CONFIG['TABLE_RESTART'] = $CONFIG['TABLE_PREFIX'].'plugin_gallery_merge_restart_data';
      $remove_backups = $remove_table = $remove_settings = $remove_logs = 'checked="checked"';  // set all options to remove
      $remove_message = '';
      $restart_db_eligible = gallery_merge_validate_option('exec_restart_db');
      $restart_files_eligible = gallery_merge_validate_option('exec_restart_files');
      $backout_db_eligible = gallery_merge_validate_option('sim_backout_db');  // (may not have run simulation yet - so validating against sim)

      if ($restart_files_eligible) {
        $remove_table = $remove_settings = '';
        $remove_message .= $lang_plugin_gallery_merge['uninstall_restart_files'].'<br />';
      }
      if ($restart_db_eligible) {
        $remove_backups = $remove_table = $remove_settings = '';
        $remove_message .= $lang_plugin_gallery_merge['uninstall_restart_db'].'<br />';
      }
      if ($backout_db_eligible) {
        $remove_backups = $remove_table = $remove_settings = '';
        $remove_message .= $lang_plugin_gallery_merge['uninstall_backout_db'].'<br />';
      }
      if ($remove_message != '') {
        $remove_message .= $lang_plugin_gallery_merge['uninstall_warning'];
      }
      echo <<< EOT
        <form action="{$cleanup}" method="post">
EOT;
      starttable('100%', '', 2);
      echo <<< EOT
        <tr>
          <td class="tableb">
            {$lang_plugin_gallery_merge['uninstall_remove_settings']}
          </td>
          <td class="tableb">
            <input type="checkbox" name="remove_settings" id="remove_settings" class="checkbox" value="1" $remove_settings />
            <label for="drop_yes" class="clickable_option">{$lang_plugin_gallery_merge['remove_settings']}</label>
          </td>
        </tr>
        <tr>
          <td class="tableb tableb_alternate">
            {$lang_plugin_gallery_merge['uninstall_remove_tables']}
          </td>
          <td class="tableb tableb_alternate">
            <input type="checkbox" name="remove_tables" id="remove_tables" class="checkbox" value="1" $remove_table />
            <label for="cache" class="clickable_option">{$lang_plugin_gallery_merge['remove_tables']}</label>
          </td>
        </tr>
        <tr>
          <td class="tableb tableb_alternate">
            {$lang_plugin_gallery_merge['uninstall_remove_backups']}
          </td>
          <td class="tableb tableb_alternate">
            <input type="checkbox" name="remove_backups" id="remove_backups" class="checkbox" value="1" $remove_backups />
            <label for="cache" class="clickable_option">{$lang_plugin_gallery_merge['remove_backups']}</label>
          </td>
        </tr>
        <tr>
          <td class="tableb tableb_alternate">
            {$lang_plugin_gallery_merge['uninstall_remove_logs']}
          </td>
          <td class="tableb tableb_alternate">
            <input type="checkbox" name="remove_logs" id="remove_logs" class="checkbox" value="1" $remove_logs />
            <label for="cache" class="clickable_option">{$lang_plugin_gallery_merge['remove_logs']}</label>
          </td>
        </tr>
EOT;
      if ($remove_message != '') {
        echo <<< EOT
          <tr>
            <td class="tablef">
            </td>
            <td class="tablef">
              {$remove_message}
            </td>
          </tr>
EOT;
      }
      echo <<< EOT
        <tr>
          <td class="tablef">
          </td>
          <td class="tablef">
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['submit_uninstall']}">{$gallery_merge_icon_array['ok']}{$lang_plugin_gallery_merge['submit_uninstall']}</button>
          </td>
        </tr>
EOT;
      endtable();
      echo <<< EOT
        </form>
EOT;
    }
}


function gallery_merge_uninstall() {
    global $CONFIG, $lang_errors;
    $superCage = Inspekt::makeSuperCage();
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    if (!$superCage->post->keyExists('submit')) {
      return 1;
    }
    // Remove plugin config records
    if ($superCage->post->keyExists('remove_settings') && $superCage->post->getInt('remove_settings') == 1) {
      // Delete the plugin config records
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_version'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_config_link'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_hide_buttons'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_local'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_filepath'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_dbserver'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_dbuser'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_dbpass'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_dbname'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_source_table_prefix'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_remove_subfolder'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_add_subfolder'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_merge_categories'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_merge_albums'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_folder_permissions'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_folder_perm_value'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_file_permissions'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_file_perm_value'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_copy_languages'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_copy_plugins'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_copy_themes'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_replace_files'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_checkpoint_freq'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_checkpoint_quiesce'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_chkpt_quiesce_files'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_message_level'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_debug'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_pictures_process'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_config_update'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_db_start'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_db_warn'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_db_end'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_db_start'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_db_end'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_dbbko_start'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_dbbko_end'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_dbbko_start'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_dbbko_end'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_files_start'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_files_end'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_files_start'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_files_end'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_sim_chkpttext'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_exec_chkpttext'");
      // non-displayed fields
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_backout_prefix'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_sim_output'");
      cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gallery_merge_ts_emer_backout'");
    }
    // Drop database tables
    if ($superCage->post->keyExists('remove_tables') && $superCage->post->getInt('remove_tables') == 1) {
      cpg_db_query("DROP TABLE IF EXISTS `{$CONFIG['TABLE_PREFIX']}plugin_gallery_merge_restart_data`");
    }
    // Drop database table backups
    if ($superCage->post->keyExists('remove_backups') && $superCage->post->getInt('remove_backups') == 1) {
      // we have dynamically created/named backup tables if gallery_merge has been executed
      $result = cpg_db_query("SHOW FULL TABLES LIKE '{$CONFIG['TABLE_PREFIX']}plugin_gallery_merge_%'");
      $rowset = cpg_db_fetch_rowset($result);
      cpg_db_free_result($result);
      foreach ($rowset AS $row) {
        $tablearray = each ($row );                                             // don't know the key - contains DBNAME and LIKE criteria - so use each to extract value
        cpg_db_query("DROP TABLE IF EXISTS `{$tablearray['value']}`");
      }
    }
    // Delete log files
    if ($superCage->post->keyExists('remove_logs') && $superCage->post->getInt('remove_logs') == 1) {
      $log_dir = './plugins/gallery_merge/logs';
      if (is_dir($log_dir)) {
        $dir = opendir($log_dir);
        while(false !== ( $file = readdir($dir)) ) {
          if (( $file != '.' ) && ( $file != '..' )) {
            unlink($log_dir.'/'.$file);                                         // delete all log files
          }
        }
      }
    }
    return true;
}
?>