<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

// array of bypass overrides..
// update this file if needed to bypass processing of specific step warnings, errors, or steps themselves.
// Any warning can be bypassed...
// You can try to bypass any error - but obviously if we can't connect to the database, bypassing it won't help much...
// Quiesce errors will ignore a bypass request (not really an error - we need to halt and restart due to time or memory limits) - these thresholds are adjustable in plugin config
// Only steps supporting checkpoint restart can be bypassed.
//   ie: early initialization steps do not support checkpoint restart - they cannot be bypassed (we can't do anything without that code running...)
// use care in specifying - there is a reason for the warnings/errors/steps to be there... You may get unpredicatable results. (But you did make a backup - right??)
// some steps have dependencies on output of previous steps - so not all can be bypassed safely.
//   ie: some db table processing creates mapping arrays used by later steps for translating data
//   bypassing step processing of TABLE_USERGROUPS, TABLE_USERS, TABLE_CATEGORIES, TABLE_ALBUMS, TABLE_PICTURES is NOT supported - and will be ignored.
// If bypassing a step that failed/quiesced in last execution - it will be honored, with appropriate messages.

// All bypasses will be reported in output and checkpointed in log - so I'll know you did it if you ask for help... :)

// $bypass_type will be set on entry to 'db' or 'files'
if ($bypass_type == 'db') {
  // each database step the issues warnings defines a $table_constant which can be specified as key to below $BYPASS arrays

  // database WARNING bypasses
  // warnings typically issued during simulations and will prevent execution from being eligible..
  // (likely need to bypass same process for ERROR during execution if you haven't addressed it by then...)
//  $BYPASS_WARNING['TABLE_CONSTANT'] = 'bypass';
//  $BYPASS_WARNING['PROCESS_VERSION_CHECK'] = 'bypass';

  // database ERROR bypasses
  // errors can be issued during simulation or execution and will halt the simulation/execution..
//  $BYPASS_ERROR['TABLE_CONSTANT'] = 'bypass';
//  $BYPASS_ERROR['PROCESS_VERSION_CHECK'] = 'bypass';

  // database STEP bypasses (last resort)
  // bypasses execution of the step
// $BYPASS['TABLE_CONSTANT'] = 'bypass';

} elseif ($bypass_type == 'files') {
  // file WARNING bypasses (curently NO WARNINGS issued by file merge...)
  // warnings typically issued during simulations and will prevent execution from being eligible..
  // (likely need to bypass same process for ERROR during execution if you haven't addressed it by then...)
// $BYPASS_WARNING['PROCESS_CONSTANT'] = 'bypass';

  // file ERROR bypasses
  // errors can be issued during simulation or execution and will halt the simulation/execution..
// $BYPASS_ERROR['PROCESS_CONSTANT'] = 'bypass';

  // file STEP bypasses (last resort)
  // each file step (that supports restart/bypass) defines a $process_constant which can be specified as key to $BYPASS array
// $BYPASS['PROCESS_CONSTANT'] = 'bypass';

  // file directory bypasses - within album directories - can bypass a directory (and all subdirectories!) if needed
  // specify the portion of directory name that FOLLOWS the album path. (This is a different format than above for steps)
// $BYPASS_DIR[] = '/pictures/subdirectory'];
}
?>