<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
  Plugin Support for gallery_merge (Gallery Merge)
**************************************************/

/*
   page included into merge_db.php to handle simulate and execution of merges for a specific plugin
   page should be named 'merge_plugin_{pluginfoldername}.php and placed in the gallery_merge/data directory
*/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

// ********************
// PLUGIN Merge Support
// ********************
/*
  Gallery Merge is a plugin to merge 2 CPG galleries..
  Creates 1 table - plugin_gallery_merge_restart_data
  - restart_data is a 'transient' data table - contains checkpoint data from executions of gallery merge
    this data can be considered transient - there is no need to merge
    script defines table as transient - which prevent other warning messages of 'unknown table found' during merge.
  - additional tables may exist containing '_bkup_' and a timestamp in name - these are all backup files and static
*/

/*
  See readme_plugin_doc.txt for detailed comments and parameters
  Unused variables or functions sections can be deleted.
*/

// ***********************
// Define Plugin Variables
// ***********************

// none needed

// ***********************
// Define Plugin Functions
// ***********************

// none needed

// *******************
// Define Plugin Array
// *******************
//** Update variables to support merge of this plugin's data tables
//** see readme_plugin_doc.txt for detailed information on parameters
$plugin_name = 'Who is online?';                                                // name as it appears in cpg_plugins table and data/plugin_data.php
// array of plugin's tables - repeat as needed for each plugin table for this plugin
// tables will be processed in the order specified... make sure to properly sequence those tables with dependencies..
// (if table b needs to translate values from table a mappings... then process (and map) a before processing b)
$plugin_table_array = array(
        'plugin_gallery_merge_restart_data' => array(                                                         // table name that follows the cpg table prefix
                                        'process_type' => 'transient'                                         // see detailed options in readme_plugin_doc.txt
                                                   ),  // end table definition

                           ); // end all tables definitions

//** add this script name to the merge_script variable for this plugin in data/plugin_data.php to have it invoked when plugin is in use in source and target galleries.
?>