<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
  Plugin Support for onlinestats (Who is online?)
**************************************************/

/*
   page included into merge_db.php to handle simulate and execution of merges for a specific plugin
   page should be named 'merge_plugin_{pluginfoldername}.php and placed in the gallery_merge/data directory
*/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

// ********************
// PLUGIN Merge Support
// ********************
/*
  'Who is online?' is a plugin to track and report those online  - and track max online number..
  Creates 1 table - mod_online.
  - mod_online is a 'transient' data table - data only retained for minutes defined in config since last interaction from user (or guest)
    no merge action will be taken.
    script defines table as transient - which prevent other warning messages of 'unknown table found' during merge.
*/

/*
  See readme_plugin_doc.txt for detailed comments and parameters
  Unused variables or functions sections can be deleted.
*/

// ***********************
// Define Plugin Variables
// ***********************

// none needed

// ***********************
// Define Plugin Functions
// ***********************

// none needed

// *******************
// Define Plugin Array
// *******************
//** Update variables to support merge of this plugin's data tables
//** see readme_plugin_doc.txt for detailed information on parameters
$plugin_name = 'Who is online?';                                                // name as it appears in cpg_plugins table and data/plugin_data.php
// array of plugin's tables - repeat as needed for each plugin table for this plugin
// tables will be processed in the order specified... make sure to properly sequence those tables with dependencies..
// (if table b needs to translate values from table a mappings... then process (and map) a before processing b)
$plugin_table_array = array(
                               'mod_online' => array(                                                         // table name that follows the cpg table prefix
                                        'process_type' => 'transient'                                         // see detailed options in readme_plugin_doc.txt
                                                   ),  // end table definition

                           ); // end all tables definitions

//** add this script name to the merge_script variable for this plugin in data/plugin_data.php to have it invoked when plugin is in use in source and target galleries.
?>