<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

// array of plugins we may encounter along the way - and their known impacts..
// additional plugins can be added to the  array definitions below - see comments for field explanations

// array of plugins - include ourselves - we know we are already in TARGET system, but our table will be found in scan if in SOURCE
// format of each sub array
//            'plugin_folder' => array('version' => '{v.r|v.r.m}',                         // v.r or v.r.m this data was collected based on
//                           'alters_cpg_tables' => {TRUE|FALSE},                          // (changes CPG base tables STRUCTURES - adding columns, etc)
//                                 'adds_tables' => {TRUE|FALSE},                          // (adds any new tables)
//                               'table_pattern' => '{pattern}',                           // (patten to match for this plugins tables (that follows cpg table prefix)
//                            'standard_folders' => {TRUE|FALSE},                          // (FALSE if folder is outside of plugins directory - should only be older 'mods')
//                                        'name' => '{name}',                              // (name of this plugin)
//                                'merge_script' => '{merge_plugin_{pluginfoldername}|needed|unknown|n/a}',    // (script to include if merge is supported for this table - .php suffix added of course)
                                              // ****** remaining fields only required if 'merge_script' is provided ******
//                                     'pid_sql' => 'SELECT SQL to return list of PIDs')   // If merge script translation will require picture (pid) information, provide SQL to generate a result
                                                                                           // set of PIDs that we care about...  Only required PIDs are mapped to conserve memory
                                                                                           // in SQL use {cpg_table_prefix} to represent prefix...
$plugin_array = array(
//                            '' => array('version' => '',
//                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
//                                        'standard_folders' => TRUE,    'folder_name' => '',
//                                        'merge_script' => 'n/a',
//                                        'pid_sql' => ''),
                'absolute_url' => array('version' => '2.0',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Absolute picture urls',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
                'album_addfav' => array('version' => '1.4',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Album addfav',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
             'album_fav_boxes' => array('version' => '2.5',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Add thumbnails to favorites',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
           'album_share_codes' => array('version' => '1.1',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Album Share Codes',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
               'album_summary' => array('version' => '1.0',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Album Summary',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
                'album_voting' => array('version' => '1.1',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => TRUE,  'table_pattern' => 'album_votes',
                                        'standard_folders' => TRUE,    'name' => 'Vote for albums',
                                        'merge_script' => 'needed',
                                        'pid_sql' => ''),
                     'cpgshop' => array('version' => '1.0.4',
                                        'alters_cpg_tables' => TRUE,   'adds_tables' => TRUE,   'table_pattern' => 'cpgshop',
                                        'standard_folders' => TRUE,    'name' => 'cpgShop',
                                        'merge_script' => 'needed',
                                        'pid_sql' => ''),
                    'cpmfetch' => array('version' => '2.1.1',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => FALSE,   'name' => 'cpmfetch',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
                      'fadein' => array('version' => '1.0',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Fade in',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
               'gallery_merge' => array('version' => '1.0',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => TRUE,   'table_pattern' => 'plugin_gallery_merge',
                                        'standard_folders' => TRUE,    'name' => 'Gallery Merge',
                                        'merge_script' => 'merge_plugin_gallery_merge.php',
                                        'pid_sql' => ''),
                 'link_target' => array('version' => '1.2',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,   'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Link target',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
                     'minicms' => array('version' => '2.3',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => TRUE,   'table_pattern' => 'cms',
                                        'standard_folders' => TRUE,    'name' => 'MiniCMS',
                                        'merge_script' => 'merge_plugin_minicms.php',
                                        'pid_sql' => "SELECT DISTINCT conid AS pid FROM {cpg_table_prefix}cms WHERE type = '2'"),
                 'onlinestats' => array('version' => '2.6',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => TRUE,   'table_pattern' => 'mod_online',
                                        'standard_folders' => TRUE,    'name' => 'Who is online?',
                                        'merge_script' => 'merge_plugin_onlinestats.php',
                                        'pid_sql' => ''),
                  'opensearch' => array('version' => '1.4',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'OpenSearch',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
                      'sample' => array('version' => '1.6',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Sample Plugin',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
           'usergal_alphatabs' => array('version' => '1.6',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'User Gallery Alphabetic Tabbing',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
           'visiblehookpoints' => array('version' => '3.4',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Visible HookPoints',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
              'watermark_mask' => array('version' => '1.1',
                                        'alters_cpg_tables' => FALSE,  'adds_tables' => FALSE,  'table_pattern' => '',
                                        'standard_folders' => TRUE,    'name' => 'Watermark Pictures and Mask URLs',
                                        'merge_script' => 'n/a',
                                        'pid_sql' => ''),
//                     'UNKNOWN' => array('version' => '',                // leave as LAST array entry
//                                        'alters_cpg_tables' => TRUE,   'adds_tables' => TRUE,   'table_pattern' => 'plugin_',    // mask to catch wayward plugin tables...
//                                        'standard_folders' => TRUE,    'name' => 'UNKNOWN',
//                                        'merge_script' => '',
//                                        'pid_sql' => '')
                                             ) // end plugin_array
//** Eliminate need for UNKNOWN entry... only used for plugin_ table mask... we should just hardcode that standard.
?>