<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (isset($gallery_merge_admin_button)) {
  // for calls from gallery_merge_config_button - we only need a single variable... save storage and don't pull in the other ~400...
  $lang_plugin_gallery_merge['adminbutton'] = 'Gallery Merge';
} else {

// plugin manager screen
$lang_plugin_gallery_merge['plugin_name'] = 'Gallery Merge';      // Your plugin's long name here
$lang_plugin_gallery_merge['plugin_description'] = 'Merge image files and database records from a source CPG gallery into a target CPG gallery.'; // Describe what your plugin does here
$lang_plugin_gallery_merge['install_info'] = 'Normal Plugin Install - Configure or use admin menu button \'Gallery Merge\' to select options and run.'; // Before the plugin is installed, this line will show in the plugin manager as additional information
$lang_plugin_gallery_merge['extra_info'] = 'For detailed information, view readme.txt in the plugin folder.'; // Extra information that shows up in the plugin manager after the plugin is installed
$lang_plugin_gallery_merge['configure_x'] = 'Configure %s'; // The %s will be replaced with the name of your plugin, so you usually don't have to edit this line
$lang_plugin_gallery_merge['execute_x'] = 'Execute %s';
$lang_plugin_gallery_merge['execute_results'] = '%s Execution Results:';
$lang_plugin_gallery_merge['simulate_results'] = '%s Simulation Results:';
$lang_plugin_gallery_merge['debug_results'] = '%s Debug Trace:';


// uninstall/cleanup functions (codebase.php)
$lang_plugin_gallery_merge['uninstall_restart_db'] = 'Restart of Gallery DB Merge is pending';
$lang_plugin_gallery_merge['uninstall_backout_db'] = 'Backout of Gallery DB Merge is possible';
$lang_plugin_gallery_merge['uninstall_restart_files'] = 'Restart of Gallery Files Merge is pending';
$lang_plugin_gallery_merge['uninstall_warning'] = 'The above actions will not be possible if additional items are removed';
$lang_plugin_gallery_merge['uninstall_remove_settings'] = 'Remove Plugin Configuration Settings';
$lang_plugin_gallery_merge['remove_settings'] = 'Remove Settings';
$lang_plugin_gallery_merge['uninstall_remove_tables'] = 'Remove Plugin Tables';
$lang_plugin_gallery_merge['remove_tables'] = 'Remove Tables';
$lang_plugin_gallery_merge['uninstall_remove_backups'] = 'Remove Plugin Created Table Backups';
$lang_plugin_gallery_merge['remove_backups'] = 'Remove Backups';
$lang_plugin_gallery_merge['uninstall_remove_logs'] = 'Remove Plugin Created Log Files';
$lang_plugin_gallery_merge['remove_logs'] = 'Remove Logs';


// configuration panel - admin.php
$lang_plugin_gallery_merge['submit'] = 'Submit Configuration Updates';
$lang_plugin_gallery_merge['submit_uninstall'] = 'Uninstall Gallery Merge';
$lang_plugin_gallery_merge['update_success'] = 'Plugin config updated';
$lang_plugin_gallery_merge['no_changes'] = 'No changes needed (or changes invalid)';
$lang_plugin_gallery_merge['merge'] = 'Simulate and Execute Dialog';
$lang_plugin_gallery_merge['adminbutton'] = 'Gallery Merge';
$lang_plugin_gallery_merge['config_link'] = 'Add Button to Admin Menu?';
$lang_plugin_gallery_merge['hide_buttons'] = 'Hide currently unusable buttons?';
$lang_plugin_gallery_merge['hide_buttons_comment'] = 'Default is to not display unusable buttons - \'Yes\' will display set disabled - some themes don\'t visually distinguish disabled';
$lang_plugin_gallery_merge['source_local'] = 'Is Source Gallery filesystem local?';
$lang_plugin_gallery_merge['source_local_comment'] = 'Local gallery uses Path to access. Remote gallery uses Source DB information';
$lang_plugin_gallery_merge['source_filepath'] = 'Path to Source Coppermine Root:';
$lang_plugin_gallery_merge['source_filepath_comment'] = 'Source filepath only required if source filesystem is local!';
$lang_plugin_gallery_merge['source_filepath_comment2'] = 'relative path from Target Coppermine Root or absolute path with document root (not http:)';
$lang_plugin_gallery_merge['source_dbserver'] = 'Source DB MySQL Connection:';
$lang_plugin_gallery_merge['source_dbserver_comment'] = 'Source connection, database, and table prefix information only required if source filesystem is remote!';
$lang_plugin_gallery_merge['source_dbuser'] = 'Source DB User Name:';
$lang_plugin_gallery_merge['source_dbpass'] = 'Source DB Password:';
$lang_plugin_gallery_merge['source_dbname'] = 'Source DB Database Name:';
$lang_plugin_gallery_merge['source_tableprefix'] = 'Source DB CPG Table Prefix:';
$lang_plugin_gallery_merge['subfolder_comment'] = "Options to remove or insert folder following album base for merged pictures (used by database AND file merge - excludes 'edit' and 'userpics' folders)";
$lang_plugin_gallery_merge['remove_subfolder'] = 'Remove Source Album Subfolder:';
$lang_plugin_gallery_merge['add_subfolder'] = 'Add Target Album Subfolder:';
$lang_plugin_gallery_merge['subfolder_comment2'] = 'specified as foldername/';
$lang_plugin_gallery_merge['merge_cat_alb_comment'] = 'Options to Merge duplicate categories and/or albums';
$lang_plugin_gallery_merge['merge_categories'] = 'Merge Duplicate Categories?';
$lang_plugin_gallery_merge['merge_categories_comment'] = 'If same named Category in SOURCE and TARGET - merge into one?';
$lang_plugin_gallery_merge['merge_albums'] = 'Merge Duplicate Albums?';
$lang_plugin_gallery_merge['merge_albums_comment'] = 'If same named Album in SOURCE and TARGET - merge into one? - Applies to \'main\' albums or user albums for same user';
$lang_plugin_gallery_merge['file_folder_permissions_comment'] = 'Options to control setting of permissions for folders/files copied (see readme.txt)';
$lang_plugin_gallery_merge['folder_permissions'] = 'Folder Permissions';
$lang_plugin_gallery_merge['file_permissions'] = 'File Permissions';
$lang_plugin_gallery_merge['default'] = 'CPG Config Default';
$lang_plugin_gallery_merge['obtain_source'] = 'Obtain from Source';
$lang_plugin_gallery_merge['use_specified'] = 'Use Specified Value';
$lang_plugin_gallery_merge['none'] = 'None';
$lang_plugin_gallery_merge['folder_permissions_comment'] = 'Permisssions to set for copied folders';
$lang_plugin_gallery_merge['file_permissions_comment'] = 'Permissions to set for created files';
$lang_plugin_gallery_merge['copy_replace_comment'] = 'Options to control copy of languages, plugins, themes, and copy/replace of pictures';
$lang_plugin_gallery_merge['copy_languages'] = 'Copy unmatched language files?';
$lang_plugin_gallery_merge['copy_plugins'] = 'Copy unmatched plugin folders?';
$lang_plugin_gallery_merge['copy_themes'] = 'Copy unmatched theme folders?';
$lang_plugin_gallery_merge['copy_languages_comment'] = 'No existing files will be replaced';
$lang_plugin_gallery_merge['copy_folders_comment'] = 'No existing folders will be replaced. Folders will not be merged.';
$lang_plugin_gallery_merge['replace_files'] = 'Replace existing picture files?';
$lang_plugin_gallery_merge['replace_files_comment'] = 'During Execute Gallery File Merge, should existing duplicate files be replaced?';
$lang_plugin_gallery_merge['checkpoint_comment'] = 'Adjust frequency of checkpoints and work limits to avoid memory and timeout limits';
$lang_plugin_gallery_merge['checkpoint_freq'] = 'DB Checkpoint Frequency:';
$lang_plugin_gallery_merge['checkpoint_freq_comment'] = 'Checkpoint progress after selected number of DB Inserts';
$lang_plugin_gallery_merge['checkpoint_quiesce'] = 'DB Quiesce Threshold:';
$lang_plugin_gallery_merge['checkpoint_quiesce_comment'] = 'Halt processing after selected number of DB Inserts (restartable)';
$lang_plugin_gallery_merge['checkpoint_quiesce_files'] = 'FILE Quiesce Threshold:';
$lang_plugin_gallery_merge['checkpoint_quiesce_files_comment'] = 'Halt processing after selected number of File Copies (restartable)';
$lang_plugin_gallery_merge['inserts'] = 'DB Inserts';
$lang_plugin_gallery_merge['copies'] = 'File Copies';
$lang_plugin_gallery_merge['message_level'] = 'Set Message level:';
$lang_plugin_gallery_merge['message_level_comment'] = 'Summary provides messages for conflicts. Detail adds insert information.';
$lang_plugin_gallery_merge['debug'] = 'Set Debug mode:';
$lang_plugin_gallery_merge['debug_comment'] = 'Summary provides code flow trace. SQL adds generated SQL. Detail adds mapping and subroutines.';
$lang_plugin_gallery_merge['summary'] = 'Summary';
$lang_plugin_gallery_merge['sql'] = 'SQL';
$lang_plugin_gallery_merge['detail'] = 'Detail';
$lang_plugin_gallery_merge['none'] = 'None';
$lang_plugin_gallery_merge['memory_comment'] = 'Options to manage memory usage for processing';
$lang_plugin_gallery_merge['pictures_process'] = 'Reduce memory used for pictures table';
$lang_plugin_gallery_merge['pictures_process_comment'] = 'Limits comparison information available for duplicates - uncheck if detailed comparison needed';
$lang_plugin_gallery_merge['register_globals_warning'] = 'WARNING: register_globals is set ON - CPG code based on this setting causes an issue for this plugin';
$lang_plugin_gallery_merge['register_globals_warning2'] = 'Set register_globals OFF to simulate/execute a Gallery Merge (or view the forum for a workaround)';
$lang_plugin_gallery_merge['register_globals_warning3'] = '(This warning only displayed if register globals is on AND a workaround is not in place)';

// buttons for simulation/execution
$lang_plugin_gallery_merge['button_comment'] = 'Only eligible items are selectable';
$lang_plugin_gallery_merge['button_comment_hidden'] = 'Only eligible items are displayed';
$lang_plugin_gallery_merge['button_set_config'] = 'Show and update plugin configuration option to enable additional options';
// DB Options
$lang_plugin_gallery_merge['simulate'] = 'Simulate Gallery DB Merge';
$lang_plugin_gallery_merge['restart_simulate'] = 'Simulate RESTART Gallery DB Merge';
$lang_plugin_gallery_merge['execute'] = 'Execute Gallery DB Merge';
$lang_plugin_gallery_merge['restart_execute'] = 'Execute RESTART Gallery DB Merge';
$lang_plugin_gallery_merge['backout_simulate'] = 'Simulate BACKOUT Gallery DB Merge';
$lang_plugin_gallery_merge['backout_execute'] = 'Execute BACKOUT Gallery DB Merge';
$lang_plugin_gallery_merge['backout_emergency'] = 'Execute EMERGENCY BACKOUT';
$lang_plugin_gallery_merge['reset_db'] = 'RESET DB Restart Flags';
// File Options
$lang_plugin_gallery_merge['simulate_file'] = 'Simulate Gallery File Merge';
$lang_plugin_gallery_merge['execute_file'] = 'Execute Gallery File Merge';
$lang_plugin_gallery_merge['restart_execute_file'] = 'Execute RESTART Gallery File Merge';
$lang_plugin_gallery_merge['reset_file'] = 'RESET File Restart Flags';
// Utility Options
$lang_plugin_gallery_merge['set_offline'] = 'Set Gallery Offline';
$lang_plugin_gallery_merge['set_online'] = 'Set Gallery Online';
$lang_plugin_gallery_merge['view_executions'] = 'View Execution Summary';
$lang_plugin_gallery_merge['view_execution_detail'] = 'View Execution Detail';
$lang_plugin_gallery_merge['gallery_compare'] = 'Post Merge Gallery Compare';
$lang_plugin_gallery_merge['test_fileperm'] = 'Test Filecopy Permissions';
$lang_plugin_gallery_merge['view_timestamp_detail'] = 'View Timestamp Detail';
$lang_plugin_gallery_merge['view_checkpoint_detail'] = 'View Checkpoint Detail';
$lang_plugin_gallery_merge['view_message_log'] = 'View Message Log';
$lang_plugin_gallery_merge['view_debug_log'] = 'View Debug Log';
// Documentation Options
$lang_plugin_gallery_merge['view_readme'] = 'View Readme Doc';
$lang_plugin_gallery_merge['view_plugin_readme'] = 'View Plugin Doc';
$lang_plugin_gallery_merge['view_plugin_list'] = 'View Plugin List';

// merge.php and included pages
$lang_plugin_gallery_merge['source'] = 'Source';
$lang_plugin_gallery_merge['source_uc'] = 'SOURCE';
$lang_plugin_gallery_merge['target'] = 'Target';
$lang_plugin_gallery_merge['target_uc'] = 'TARGET';
$lang_plugin_gallery_merge['simulation'] = 'Simulation';
$lang_plugin_gallery_merge['execution'] = 'Execution';
$lang_plugin_gallery_merge['display'] = 'Display';
$lang_plugin_gallery_merge['started'] = 'Started';
$lang_plugin_gallery_merge['restarted'] = '*Restarted*';
$lang_plugin_gallery_merge['completed'] = 'Completed';

// merge_db.php
$lang_plugin_gallery_merge['processing_version_check'] = 'CPG Version Check';
$lang_plugin_gallery_merge['processing_version_check_comment'] = 'Comparing CPG version/maintenance level of Source and Target';
$lang_plugin_gallery_merge['processing_version_check_complete'] = 'CPG version check completed';
$lang_plugin_gallery_merge['processing_backup'] = 'Processing CPG tables backup';
$lang_plugin_gallery_merge['processing_backup_comment'] = 'Backing up core CPG tables that will be updated';
$lang_plugin_gallery_merge['processing_backup_complete'] = 'Table backups completed';
$lang_plugin_gallery_merge['processing_plugin_tables'] = 'Processing PLUGIN tables';
$lang_plugin_gallery_merge['processing_plugin_tables_comment'] = 'Source tables will be MERGED into Target for supported PLUGINs';
$lang_plugin_gallery_merge['processing_plugin'] = 'Processing \'%s\' tables';                                                        // %s is Plugin Name
$lang_plugin_gallery_merge['processing_plugin_complete'] = '\'%s\' processing complete';                                             // %s is Plugin Name
$lang_plugin_gallery_merge['processing_compare_tables'] = 'Comparing CPG tables';
$lang_plugin_gallery_merge['processing_compare_tables_comment'] = 'Core CPG tables will be compared';
$lang_plugin_gallery_merge['processing_compare_tables_complete'] = 'Table compare completed';

// merge.plugin.inc.php
$lang_plugin_gallery_merge['processing_plugins_backup'] = 'Processing %s Backup';                                                    // %s is plugin table name
$lang_plugin_gallery_merge['processing_plugins_backup_comment'] = 'Table will be backed up before updates';
$lang_plugin_gallery_merge['processing_plugins_backup_completed'] = 'PLUGIN table %s Backup completed';                              // %s is plugin table constant

// merge_backout_db
$lang_plugin_gallery_merge['backout_execute_warning'] = 'WARNING: Backout will restore tables updated to state at beginning of execution';
$lang_plugin_gallery_merge['backout_execute_warning2'] = 'Any updates made since that time will be lost!';
$lang_plugin_gallery_merge['backout_emergency_warning'] = 'WARNING: EMERGENCY BACKOUT requested in CONFIG to timestamp %s';          // %s is formatted timestamp
$lang_plugin_gallery_merge['processing_restore'] = 'Processing CPG tables restore';
$lang_plugin_gallery_merge['processing_restore_comment'] = 'Updated tables will be reset to status as of %s';                        // %s is formatted timestamp
$lang_plugin_gallery_merge['processing_restore_missing'] = 'Missing backup file for core CPG table %s';                              // %s is table name constant
$lang_plugin_gallery_merge['processing_restore_complete'] = 'Table restores completed';
$lang_plugin_gallery_merge['backout_emergency_complete'] = 'EMERGENCY BACKOUT completed - CONFIG option reset';

// merge_files.php
$lang_plugin_gallery_merge['compare_languages'] = 'Comparing Language Files';
$lang_plugin_gallery_merge['compare_languages_comment'] = 'Processing SOURCE and TARGET Language Files for missing files';
$lang_plugin_gallery_merge['compare_languages_complete'] = 'Language file processing completed';
$lang_plugin_gallery_merge['compare_plugins'] = 'Comparing Plugin Directories';
$lang_plugin_gallery_merge['compare_plugins_comment'] = 'Processing SOURCE and TARGET Plugin Directories for missing folders';
$lang_plugin_gallery_merge['compare_plugins_complete'] = 'Plugin directory processing completed';
$lang_plugin_gallery_merge['compare_themes'] = 'Comparing Theme Directories';
$lang_plugin_gallery_merge['compare_themes_comment'] = 'Processing SOURCE and TARGET Theme Directories for missing folders';
$lang_plugin_gallery_merge['compare_themes_complete'] = 'Theme directory processing completed';
$lang_plugin_gallery_merge['compare_directories'] = 'Comparing Album Directories';
$lang_plugin_gallery_merge['compare_directories_comment'] = 'Comparing SOURCE and TARGET Album directory structures for conflicts';
$lang_plugin_gallery_merge['compare_directories_remove'] = 'Folder \'%s\' will be removed from TARGET album path where present';     // %s is folder name
$lang_plugin_gallery_merge['compare_directories_add'] = 'Folder \'%s\' will be added to TARGET album path';                          // %s is folder name
$lang_plugin_gallery_merge['compare_directories_complete'] = 'Directory compare completed';
$lang_plugin_gallery_merge['compare_files'] = 'Comparing Album Files';
$lang_plugin_gallery_merge['compare_files_comment'] = 'Comparing SOURCE and TARGET Album files in common directories ONLY for conflicts';
$lang_plugin_gallery_merge['compare_files_complete'] = 'File compare completed';
$lang_plugin_gallery_merge['copy_files'] = 'Copy Album Directories and Files';
$lang_plugin_gallery_merge['copy_files_comment'] = 'Copying SOURCE Album directories/files to TARGET Albums directory';
$lang_plugin_gallery_merge['copy_files_comment2'] = '\'edit\' folder excluded - \'userpics\' will be processed separately below';
$lang_plugin_gallery_merge['copy_files_detail'] = 'Copying SOURCE \'%1$s\' directories/files to TARGET \'%2$s\'';                    // %1$s is source path; %2$s is target path
$lang_plugin_gallery_merge['copy_files_complete'] = 'Copy of SOURCE Directories/Files to TARGET Complete - %u Files copied';         // %u is integer count
$lang_plugin_gallery_merge['verify_files'] = 'Verify Album Directories and Files';
$lang_plugin_gallery_merge['verify_files_comment'] = 'Comparing SOURCE and TARGET Album directory/file structures for validation';
$lang_plugin_gallery_merge['verify_files_complete'] = 'Album directory validation processing completed.';
$lang_plugin_gallery_merge['copy_userpics'] = 'Compare and Copy Userpics';
$lang_plugin_gallery_merge['copy_userpics_comment'] = 'Copying SOURCE Album Userpics directories/files to TARGET Albums Userpics directory';
$lang_plugin_gallery_merge['copy_userpics_detail'] = 'Copying SOURCE \'%1$s\' directories/files to TARGET \'%2$s\'';                 // %1$s is source path; %2$s is target path
$lang_plugin_gallery_merge['copy_userpics_complete'] = 'Copy of SOURCE Directories/Files to TARGET Complete - %u Files copied (total)'; // %u is integer count
$lang_plugin_gallery_merge['verify_userpics'] = 'Verify Userpics Directories and Files';
$lang_plugin_gallery_merge['verify_userpics_comment'] = 'Comparing SOURCE and TARGET Userpics directory/file structures for validation';
$lang_plugin_gallery_merge['verify_userpics_complete'] = 'Userpics directory validation processing completed.';
$lang_plugin_gallery_merge['compare_cpg'] = 'Compare CPG Directories and Files';
$lang_plugin_gallery_merge['compare_cpg_comment'] = 'Processing remaining SOURCE and TARGET CPG Directories';
$lang_plugin_gallery_merge['compare_cpg_comment2'] = 'Report SOURCE files not in TARGET - NO ACTIONS will be taken';
$lang_plugin_gallery_merge['compare_cpg_complete'] = 'CPG directory processing completed';

// merge_utility.php
$lang_plugin_gallery_merge['utility_compare_title'] = '%s Utility Gallery Compare';                                                  // %s is plugin name
$lang_plugin_gallery_merge['utility_testperm_title'] = '%s Utility Test Copy Permissions';                                           // %s is plugin name
$lang_plugin_gallery_merge['utility_view_title'] = '%s Utility Data View';                                                           // %s is plugin name
$lang_plugin_gallery_merge['utility_reset_db_title'] = '%s Utility DB Data Reset';                                                   // %s is plugin name
$lang_plugin_gallery_merge['utility_reset_files_title'] = '%s Utility Files Data Reset';                                             // %s is plugin name
$lang_plugin_gallery_merge['utility_setstatus_title'] = '%s Utility Set Gallery Status';                                             // %s is plugin name
$lang_plugin_gallery_merge['utility_doc_view_title'] = '%s View Documentation';                                                      // %s is plugin name
// reset statistics
$lang_plugin_gallery_merge['utility_reset_db'] = 'Reset DB Statistics';
$lang_plugin_gallery_merge['utility_reset_db_comment'] = 'All DB simulation/execution times will be reset. Backout/restart will no longer be possible';
$lang_plugin_gallery_merge['utility_reset_db_complete'] = 'Database Execution Timestamps Reset';
$lang_plugin_gallery_merge['utility_reset_file'] = 'Reset File Statistics';
$lang_plugin_gallery_merge['utility_reset_file_comment'] = 'All File simulation/execution times will be reset. Restart will no longer be possible';
$lang_plugin_gallery_merge['utility_reset_files_complete'] = 'Files Execution Timestamps Reset';
// set gallery offline/online
$lang_plugin_gallery_merge['utility_set_offline'] = 'Set Gallery Offline';
$lang_plugin_gallery_merge['utility_set_offline_comment'] = 'Gallery will be offline to all but admin users';
$lang_plugin_gallery_merge['utility_set_online'] = 'Set Gallery Online';
$lang_plugin_gallery_merge['utility_set_online_comment'] = 'Gallery will be online to all users';
// view executions
$lang_plugin_gallery_merge['utility_execution_summary'] = 'View Execution Summary';
$lang_plugin_gallery_merge['utility_execution_summary_comment'] = 'All Simulation and Executions currently recorded (newest on top)';
$lang_plugin_gallery_merge['utility_execution_summary_complete'] = 'Execution summary display completed';
$lang_plugin_gallery_merge['utility_execution_detail'] = 'View Execution Detail';
$lang_plugin_gallery_merge['utility_execution_detail_comment'] = 'Detail records for execution at timestamp %s';                     // %s is formatted timestamp
$lang_plugin_gallery_merge['utility_execution_detail_no_ts']= 'ERROR: No timestamp provided';
$lang_plugin_gallery_merge['utility_execution_detail_complete'] = 'Execution detail display completed';
$lang_plugin_gallery_merge['db_simulation'] = 'Database Merge Simulation';
$lang_plugin_gallery_merge['db_execution'] = 'Database Merge Execution';
$lang_plugin_gallery_merge['files_simulation'] = 'File Merge Simulation';
$lang_plugin_gallery_merge['files_execution'] = 'File Merge Execution';
$lang_plugin_gallery_merge['utility_execution_detail_file_count']= '%1$u Files ending with Folder \'%2$s\'';                         // %1$u is row count; %2$s is folder name
$lang_plugin_gallery_merge['utility_execution_detail_insert_count']= '%1$u Inserts ending with Key \'%2$s\'';                        // %1$u is row count; %2$s is table key value
$lang_plugin_gallery_merge['utility_execution_detail_quiesce_point']= 'Threshold reached at key/folder \'%s\'';                      // %s is key or folder
$lang_plugin_gallery_merge['utility_execution_backups'] = 'Backups exist for the following tables';
$lang_plugin_gallery_merge['utility_execution_backups_list'] = '%1$s backup contains %2$u rows';                                     // %1$s is tablename; %2$u is row count
$lang_plugin_gallery_merge['utility_execution_backups_none'] = 'No table backups found';
$lang_plugin_gallery_merge['utility_execution_sql_view'] = 'View/Download SQL Log File';
$lang_plugin_gallery_merge['utility_execution_sql_none'] = 'No sql log file found';
// view checkpoint detail
$lang_plugin_gallery_merge['utility_checkpoint_detail'] = 'View Checkpoint Detail';
$lang_plugin_gallery_merge['utility_checkpoint_detail_none'] = 'No checkpoint detail data found';
// view message/debug logs
$lang_plugin_gallery_merge['utility_log'] = 'View of %1$s log from %2$s';                                                            // %1$s is message|debug; %2$s is formatted timestamp
$lang_plugin_gallery_merge['utility_log_view'] = 'View %s Log';                                                                      // %s is message|debug (next 2 lines...)
$lang_plugin_gallery_merge['utility_log_message'] = 'message';
$lang_plugin_gallery_merge['utility_log_debug'] = 'debug';
$lang_plugin_gallery_merge['utility_log_not_found'] = 'File Not Found';
// gallery compare (post merge) - messages without 'utility_' prefix are 'shared' with earlier code
$lang_plugin_gallery_merge['utility_compare_files_comment'] = 'Comparing SOURCE and TARGET Album directory/file structures for validation';
$lang_plugin_gallery_merge['utility_compare_files_complete'] = 'Album directory validation processing completed';
$lang_plugin_gallery_merge['utility_compare_files_bypass'] = 'File compare bypassed - File merge not yet executed for this configuration';
$lang_plugin_gallery_merge['utility_compare_files_cpg_comment'] = 'Comparing Remaining SOURCE and TARGET CPG Directories for validation';
$lang_plugin_gallery_merge['utility_compare_files_cpg_comment2'] = 'Report SOURCE files not in TARGET - NO ACTIONS will be taken';
$lang_plugin_gallery_merge['utility_compare_files_cpg_complete'] = 'CPG directory validation processing completed';
$lang_plugin_gallery_merge['utility_compare_db'] = 'Comparing CPG tables';
$lang_plugin_gallery_merge['utility_compare_db_comment'] = 'Core CPG tables will be compared for validation';
$lang_plugin_gallery_merge['utility_compare_db_complete'] = 'CPG table validation processing completed';
$lang_plugin_gallery_merge['utility_compare_db_bypass'] = 'DB compare bypassed - DB merge not yet executed for this configuration';
// test permissions
$lang_plugin_gallery_merge['utility_perms'] = 'Test Folder/File Permissions';
$lang_plugin_gallery_merge['utility_perms_comment'] = 'Create folders/files with different permission methods';
$lang_plugin_gallery_merge['utility_perms_test_folders_exist'] = 'One or more of following folders already exist';
$lang_plugin_gallery_merge['utility_perms_test_folders_exist2'] = 'Please delete folders and re-run';
$lang_plugin_gallery_merge['utility_perms_create_folder_cpgdefault'] = 'Creating folder %1$s using CPG Config set permissions \'%2$s\''; // %1$s is folder; %2$s is permissions value
$lang_plugin_gallery_merge['utility_perms_create_folder_source'] = 'Creating folder %1$s using permissions from \'%2$s\'';           // %1$s is folder; %2$s is album filepath
$lang_plugin_gallery_merge['utility_perms_create_folder_specified'] = 'Creating folder %1$s using specified permissions of \'%2$s\'';// %1$s is folder; %2$s is permissions value
$lang_plugin_gallery_merge['utility_perms_create_folder_default'] = 'Creating folder %s using default (inherited) permissions';      // %s is destination folders
$lang_plugin_gallery_merge['utility_perms_file_not_found'] = 'Source file %s from cpg_pictures table can not be found';              // %s is lastpic added filename
$lang_plugin_gallery_merge['utility_perms_create_file'] = 'Copying file at $s';                                                      // %s is source filepath
$lang_plugin_gallery_merge['utility_perms_create_file_cpgdefault'] = 'To %1$s using CPG Config set permissions \'%2$s\'';              // %1$s is folder; %2$s is permissions value
$lang_plugin_gallery_merge['utility_perms_create_file_source'] = 'To %1$s using permissions from \'%2$s\'';                          // %1$s is destination filepath; %2$s is source filepath
$lang_plugin_gallery_merge['utility_perms_create_file_specified'] = 'To %1$s using specified permissions of \'%2$s\'';               // %1$s is destination filepath; %2$s is permissions value
$lang_plugin_gallery_merge['utility_perms_create_file_default'] = 'To %s using default (inherited) permissions';                     // %s is destination filepath
$lang_plugin_gallery_merge['utility_perms_result'] = 'Review results in your sites File Manager to see which option works best for your host';
$lang_plugin_gallery_merge['utility_perms_result2'] = 'Test folders/files listed above can be deleted anytime (and before re-running this function)';
// view plugin list
$lang_plugin_gallery_merge['utility_plugin_defined_supported'] = 'Defined and/or Supported Plugins';
$lang_plugin_gallery_merge['utility_plugin_name'] = 'Plugin Name';
$lang_plugin_gallery_merge['utility_plugin_version'] = 'Last Version Reviewed';
$lang_plugin_gallery_merge['utility_plugin_details'] = 'Plugin Details';
$lang_plugin_gallery_merge['utility_plugin_alters_cpg_tables'] = 'Alters CPG Core Tables';
$lang_plugin_gallery_merge['utility_plugin_adds_tables'] = 'Adds tables to database';
$lang_plugin_gallery_merge['utility_plugin_data_merge_required'] = 'NOTE: Merge Script (or manual action) required! - Data Merge not supported (yet!)';
$lang_plugin_gallery_merge['utility_plugin_data_merge_supported'] = 'Data merge supported';
$lang_plugin_gallery_merge['utility_plugin_no_data_impact'] = 'Plugin has no data impact on merge processing';

// functions.php
// gallery access control
$lang_plugin_gallery_merge['gallery_status'] = 'Gallery Status:';
$lang_plugin_gallery_merge['gallery_warn_offline'] = 'WARNING: Gallery is currently offline. Reset in Admin Config if this is not desired state.';
$lang_plugin_gallery_merge['gallery_warn_online'] = 'WARNING: Gallery is currently online. Offline status is recommended for gallery merge execution.';
$lang_plugin_gallery_merge['gallery_set_offline'] = 'Gallery set offline for gallery merge execution.';
$lang_plugin_gallery_merge['gallery_set_online'] = 'Gallery set online.';
$lang_plugin_gallery_merge['gallery_reset_offline'] = 'Gallery reset to offline status.';
$lang_plugin_gallery_merge['gallery_reset_online'] = 'Gallery reset to online status.';
$lang_plugin_gallery_merge['gallery_offline'] = 'Gallery already offline.';
$lang_plugin_gallery_merge['gallery_online'] = 'Gallery already online.';
// checkpoint and bypass
$lang_plugin_gallery_merge['bypass_warning_requested'] = 'Bypass of WARNINGS from \'%s\' requested';                                 // %s is process_name
$lang_plugin_gallery_merge['bypass_error_requested'] = 'Bypass of ERRORS from \'%s\' requested';                                     // %s is process_name
$lang_plugin_gallery_merge['bypass_step_requested'] = 'Bypass of STEP \'%s\' requested';                                             // %s is process_name
$lang_plugin_gallery_merge['bypass_step_requested_backout'] = 'Bypass of previously backed out STEP \'%s\' requested';               // %s is process_name
$lang_plugin_gallery_merge['bypass_step_requested_failure'] = 'WARNING: Bypass of previously FAILED STEP \'%1$s\' requested - Restart status: \'%2$s\''; // %1$s is process_name; %2$s is restart status
$lang_plugin_gallery_merge['bypass_dir_requested'] = 'Bypass of DIRECTORY \'%s\' requested';                                         // %s is process_name
$lang_plugin_gallery_merge['bypass_error_prefix'] = 'ERROR BYPASS: ';
$lang_plugin_gallery_merge['bypass_warning_prefix'] = 'WARNING BYPASS: ';
// gallery connections
$lang_plugin_gallery_merge['request_merge_local'] = 'Request to merge local Gallery at path %1$s into Gallery %2$s';                 // %1$s is local source filepath; %2$s is target gallery name
$lang_plugin_gallery_merge['request_merge_remote'] = 'Request to merge remote Gallery database at %1$s into Gallery %2$s';           // %1$s is remote source db server; %2$s is target gallery name';
$lang_plugin_gallery_merge['open_source_db'] = 'Opening Source Database';
// backup and restore
$lang_plugin_gallery_merge['backup_complete'] = '%s back up completed';                                                              // %s is table name
$lang_plugin_gallery_merge['backup_bypassed'] = '%s back up bypassed (Simulation)';                                                  // %s is table name
$lang_plugin_gallery_merge['restore_complete'] = '%s restore completed';                                                             // %s is table name
$lang_plugin_gallery_merge['restore_bypassed'] = '%s restore bypassed (Simulation)';                                                 // %s is table name
// merge db
$lang_plugin_gallery_merge['version_match'] = 'Both Source and Target Galleries at running version %s';                              // %s is version number (v.r.m)
$lang_plugin_gallery_merge['version_mismatch'] = 'WARNING: Source gallery is version %1$s - Target gallery is version %2$s';         // %1$s is source version; %2$s is target version                     // %s is version number (v.r.m)
$lang_plugin_gallery_merge['version_notfound'] = 'WARNING: Unable to locate source version - Target gallery is version %s';          // %s is target version                     // %s is version number (v.r.m)
$lang_plugin_gallery_merge['version_noinit'] = 'WARNING: Unable to locate init.inc.php with source version - Target gallery is version %s'; // %s is target version                     // %s is version number (v.r.m)
$lang_plugin_gallery_merge['version_remote'] = 'Unable to obtain version for remote Source - Target gallery is version %s';          // %s is target version                     // %s is version number (v.r.m)
$lang_plugin_gallery_merge['structure_obsolete_source'] = 'Source table \'%1$s\' contains obsolete field \'%2$s\' not in Target - will be omitted'; // %1$s is table name; %2$s is field name
$lang_plugin_gallery_merge['structure_obsolete_both'] = 'Source table \'%1$s\' contains obsolete field \'%2$s\' also in Target - will be maintained'; // %1$s is table name; %2$s is field name
$lang_plugin_gallery_merge['structure_not matched'] = 'WARNING: Source table \'%1$s\' contains field \'%2$s\' not in Target - unable to merge'; // %1$s is table name; %2$s is field name
$lang_plugin_gallery_merge['userpics_map_warning'] = 'WARNING: Unable to map SOURCE USER \'%s\' to translate uploaded userpics';     // %s is user_id
$lang_plugin_gallery_merge['processing_table'] = 'Processing %s table';                                                              // %s is table name
$lang_plugin_gallery_merge['source_merged'] = 'Source table will be MERGED into Target';
$lang_plugin_gallery_merge['limited_compare'] = 'Comparison of duplicates limited to field(s) \'%s\' - Reduced memory usage';        // %s is comma separated list of field names
$lang_plugin_gallery_merge['messages_suppressed'] = 'Insert messages suppressed for %s table';                                       // %s is table name
$lang_plugin_gallery_merge['row_inserted'] = '%1$s \'%2$s\' will be inserted into TARGET';                                           // %1$s is table name; %2$s is inserted data
$lang_plugin_gallery_merge['row_inserted_dup'] = '%1$s \'%2$s\' will be inserted into TARGET (duplicate allowed)';                   // %1$s is table name; %2$s is inserted data
$lang_plugin_gallery_merge['row_exists'] = '%1$s \'%2$s\' in SOURCE gallery already in TARGET gallery';                              // %1$s is table name; %2$s is existing data
$lang_plugin_gallery_merge['target_duplicate'] = 'Source contains row which has duplicates in TARGET based on \'%s\' compare fields'; // $s is compare fields
$lang_plugin_gallery_merge['target_duplicate2'] = 'Unable to perform UNIQUE mapping requested';
$lang_plugin_gallery_merge['inserted_existed'] = '%1$u %3$s inserted - %2$u %3$s already existed';                                   // %1$u is insert count; %2$u is existed count; %3$s is table
$lang_plugin_gallery_merge['rebuild_category'] = 'Category trees rebuilt';
$lang_plugin_gallery_merge['rebuild_album'] = 'Album positions verified - %u updated';                                               // %u is count updated
$lang_plugin_gallery_merge['processing_references'] = 'Processing Picture References';
$lang_plugin_gallery_merge['updating_references'] = 'Updating references to pictures in categories and albums';
$lang_plugin_gallery_merge['references_updated'] = '%1$u categories updated - %2$u albums updated';                                  // %1$u is updates cats; %2$u is updated albums
$lang_plugin_gallery_merge['no_merge'] = 'Any conflicts need to be manually resolved. No merge will be done of this table.';
$lang_plugin_gallery_merge['source_not_in_target'] = '%1$s SOURCE setting %2$s not in TARGET %1$s';                                  // %1$s is table name; %2$s is missing setting
$lang_plugin_gallery_merge['source_does_not_match'] = '%1$s SOURCE setting %2$s does not match TARGET setting of %3$s';              // %1$s is table name; %2$s is source setting; %3$s is target setting
$lang_plugin_gallery_merge['plugin_related'] = 'Setting is Plugin related';
$lang_plugin_gallery_merge['table_complete'] = '%s table processing complete';                                                       // %s is table name
$lang_plugin_gallery_merge['no_merge_plugin_note'] = 'NOTE: Some plugins add fields to CPG tables. If these fields are in SOURCE, and not TARGET tables, DB merge execution will fail.';
$lang_plugin_gallery_merge['no_merge_plugin_note2'] = 'Some plugins add tables to CPG. If these tables are in SOURCE, and not TARGET database, and merge is supported, DB merge execution will fail.';
$lang_plugin_gallery_merge['no_merge_plugin_note2a'] = 'If merge is not supported, any data in these tables will be lost.';
$lang_plugin_gallery_merge['plugin_alters_cpg_tables'] = 'WARNING: Plugin alters CPG Core Tables - merge will FAIL if not installed in TARGET gallery!';
$lang_plugin_gallery_merge['plugin_adds_data_warning'] = 'WARNING: Plugin tables contain data that will not be merged - no merge support!';
$lang_plugin_gallery_merge['plugin_adds_data_not_installed'] = 'WARNING: Plugin tables contain content data that will not be merged - plugin not in TARGET!';
$lang_plugin_gallery_merge['plugin_data_merge_not_required'] = 'Plugin tables data merge not required';
$lang_plugin_gallery_merge['plugin_data_merge_supported'] = 'Data merge will be performed for this plugin';
$lang_plugin_gallery_merge['plugin_no_data_impact'] = 'Plugin has no data impact on merge processing';
$lang_plugin_gallery_merge['plugin_unknown'] = 'UNKNOWN plugin - Impact to merge is Unknown - please review!';
$lang_plugin_gallery_merge['plugin_unknown_alter'] = 'UNKNOWN plugin - Impact to CPG Core Tables is Unknown - please review!';
$lang_plugin_gallery_merge['plugin_not_installed'] = 'PLUGIN \'%s\' in SOURCE gallery not installed in TARGET gallery';              // %s is plugin name
$lang_plugin_gallery_merge['plugin_already_installed'] = 'PLUGIN \'%s\' in SOURCE gallery already installed in TARGET gallery';      // %s is plugin name
$lang_plugin_gallery_merge['static_table'] = 'Table only maintained by maintenance - no action taken';
$lang_plugin_gallery_merge['static_rows_match'] = '%1$s SOURCE and TARGET both contain %2$u rows';                                   // %1$s is table name; %2$u is row count
$lang_plugin_gallery_merge['static_rows_mismatch'] = '%1$s mismatch - SOURCE contains %2$u rows - TARGET contains %3$u rows';        // %1$s is table name; %2$u is source row count; %3$u is target row count
$lang_plugin_gallery_merge['optional_table'] = 'Table is optional - will be rebuilt if used';
$lang_plugin_gallery_merge['optional_no_action'] = 'no action required';
$lang_plugin_gallery_merge['optional_rebuild'] = 'table will be rebuilt';
$lang_plugin_gallery_merge['optional_counts'] = '%1$s SOURCE contains %2$u rows - TARGET contains %3$u rows';                        // %1$s is table name; %2$u is source row count; %3$u is target row count
$lang_plugin_gallery_merge['optional_rebuild_complete'] = 'TARGET table rebuilt. Contains %u rows';                                  // %u is target row count
$lang_plugin_gallery_merge['transient_table'] = 'Table is transient - no action taken';
$lang_plugin_gallery_merge['table_count'] = '%1$s SOURCE contains %2$u rows';                                                        // %1$s is table name; %2$u is source row count
$lang_plugin_gallery_merge['unused_table'] = 'Table is not currently used in TARGET gallery (config option) - no action taken';
$lang_plugin_gallery_merge['unsupported_table'] = 'Table is unsupported by merge process - no action taken';
$lang_plugin_gallery_merge['unknown_tables'] = 'Scanning for unknown CPG tables - These will NOT be processed';
$lang_plugin_gallery_merge['unknown_plugin_table'] = '%s SOURCE table found - not processed';                                        // %s is table name
$lang_plugin_gallery_merge['unknown_plugin_install_needed'] = 'Installed \'%s\' Plugin adds this table - merge not supported';       // %s is plugin name
$lang_plugin_gallery_merge['unknown_plugin_install_nomerge'] = 'Installed \'%s\' Plugin adds this table - merge not needed';         // %s is plugin name
$lang_plugin_gallery_merge['unknown_plugin_install_merge'] = 'Table matches pattern of installed \'%s\' Plugin - merge supported, but this table not addressed'; // %s is plugin name
$lang_plugin_gallery_merge['unknown_plugin_uninst_needed'] = '\'%s\' Plugin adds this table - merge not supported and plugin not installed in SOURCE';  // %s is plugin name
$lang_plugin_gallery_merge['unknown_plugin_uninst_nomerge'] = '\'%s\' Plugin adds this table - merge not needed and plugin not installed in SOURCE';    // %s is plugin name
$lang_plugin_gallery_merge['unknown_plugin_uninst_merge'] = '\'%s\' Plugin adds this table - merge supported, but plugin not installed in SOURCE';      // %s is plugin name
$lang_plugin_gallery_merge['unknown_plugin_gallery_merge_bkup'] = '\'%s\' Plugin backup data - merge not required';                  // %s is plugin name
$lang_plugin_gallery_merge['unknown_table'] = '%s SOURCE table found - not processed - UNKNOWN TABLE FOUND';                         // %s is table name
$lang_plugin_gallery_merge['verifying_table'] = 'Verifying %s table';                                                                // %s is table name
$lang_plugin_gallery_merge['verifying_table_comment'] = 'Source table being COMPARED to Target table';
$lang_plugin_gallery_merge['match_messages_suppressed'] = 'Matching messages suppressed for %s table';                               // %s is table name
$lang_plugin_gallery_merge['verify_missing'] = '%1$s \'%2$s\' missing from TARGET';                                                  // %1$s is table name; %2$s is missing key
$lang_plugin_gallery_merge['verify_match'] = '%1$s \'%2$s\' in SOURCE gallery already in TARGET gallery';                            // %1$s is table name; %2$s is matching key
$lang_plugin_gallery_merge['verify_counts'] = '%2$u %1$s missing - %3$u %1$s existed';                                               // %1$s is table name; %2$u is count missing; %3$u is count existed
// merge files
$lang_plugin_gallery_merge['compare_directory_item'] = '%1$s file/folder \'%2$s\' missing from TARGET gallery';                      // %1$s is type (language|theme|plugin); %2$s is name
$lang_plugin_gallery_merge['compare_directory_copy'] = '%s will be copied to TARGET';                                                // %s is type
$lang_plugin_gallery_merge['compare_directory_nocopy'] = 'WARNING: %s will NOT be copied to TARGET based on current settings';       // %s is type
$lang_plugin_gallery_merge['compare_plugin_adds_folder'] = '%s Plugin adds this folder';                                             // %s is plugin name
$lang_plugin_gallery_merge['compare_directory_copied'] = '%1$u %2$s copied to TARGET gallery';                                       // %1$u is count; %2$s is type
$lang_plugin_gallery_merge['compare_anycontent_mismatch'] = '/anycontent.php is %1$u bytes in SOURCE and %2$u in TARGET!';           // %1$u is source bytes; %2$u is target bytes
$lang_plugin_gallery_merge['compare_filetype_conflict'] = '%s is FILE in SOURCE and DIRECTORY in TARGET gallery - Unable to complete compare!';     // %s is target file
$lang_plugin_gallery_merge['compare_dirtype_conflict'] = '%s is DIRECTORY in SOURCE and FILE in TARGET gallery - Unable to complete compare!';      // %s is target file
$lang_plugin_gallery_merge['compare_file_missing'] = '%s FILE in SOURCE gallery missing from TARGET gallery';                        // %s is source file
$lang_plugin_gallery_merge['compare_dir_missing'] = '%s DIRECTORY in SOURCE gallery missing from TARGET gallery';                    // %s is source directory
$lang_plugin_gallery_merge['compare_dir_bypassed'] = '%s DIRECTORY in SOURCE gallery BYPASSED';                                      // %s is source directory
$lang_plugin_gallery_merge['plugin_adds_folder'] = '%s folder added by plugin';                                                      // %s is folder name
$lang_plugin_gallery_merge['userpics_nomatch'] = 'WARNING: Unable to match USER %s in target to copy uploaded userpics';             // %s is user name (user id)
$lang_plugin_gallery_merge['compare_directory_merge'] = '%s DIRECTORY already exists in TARGET gallery albums directory - contents will be merged'; // %s is directory name
$lang_plugin_gallery_merge['compare_directory_copy'] = '%s  DIRECTORY in SOURCE gallery will be copied to TARGET gallery"';          // %s is directory name
$lang_plugin_gallery_merge['compare_file_conflict'] = 'WARNING: %s in SOURCE gallery already exists in TARGET gallery albums directory';            // %s is source file
$lang_plugin_gallery_merge['compare_file_copy'] = '%s FILE in SOURCE gallery will be copied to TARGET gallery';                      // %s is source file
$lang_plugin_gallery_merge['recurse_copy_quiesce'] = 'Copy of SOURCE Directories/Files to TARGET Quiesced after %u Files copied';    // %u is target files copied count
$lang_plugin_gallery_merge['verify_directories_counts'] = '%1$u Directories missing - %2$u Directories existed';                     // %1$u is missing count; %2$u is existed count
$lang_plugin_gallery_merge['verify_directories_bypassed'] = ' - %u Directories bypassed';                                            // %u is bypassed count
$lang_plugin_gallery_merge['verify_files_counts'] = '%1$u Files missing - %2$u Files existed';                                       // %1$u is missing count; %2$u is existed count
//$lang_plugin_gallery_merge['mod_adds_folder'] = 'Mod adds this folder';                                                              // 'non-standard' plugin - old style mod

// gallery_merge_error - error, warning, and info messages displayed in message boxes
// error messages
$lang_plugin_gallery_merge['e_invalid_restart_time'] = 'Invalid restart request at timestamp %1$s (Config indicates %2$s)';          // %1$s is requested timestamp; %2$s is config timestamp
$lang_plugin_gallery_merge['e_invalid_backout_time'] = 'Invalid backout request at timestamp %1$s (Config indicates %2$s)';          // %1$s is requested timestamp; %2$s is config timestamp
$lang_plugin_gallery_merge['e_invalid_checkpoint'] = 'Checkpoint Restart: Unexpected checkpoint record encountered for %1$s Status: %2$s Restart table: %3$s - Restart aborted'; // %1$s is table constant; %2$s is status; %3$s is restart table data
$lang_plugin_gallery_merge['e_invalid_filepath_length'] = 'Source filepath not valid - too short (<= 1)';
$lang_plugin_gallery_merge['e_unable_locate_config'] = 'Unable to locate Source Coppermine configuration';
$lang_plugin_gallery_merge['e_source_target_same'] = 'Source and target are same gallery - no merge allowed';
$lang_plugin_gallery_merge['e_unable_connect_source'] = 'Unable to connect/select SOURCE database';
$lang_plugin_gallery_merge['e_version_mismatch'] = 'Source and Target at different CPG maintenance level - Execution aborted';
$lang_plugin_gallery_merge['e_tablename_length'] = 'Backup table name exceeds 64 characters - Execution aborted - adjust \'plugin_gallery_merge_backout_prefix\' in cpg_config';
$lang_plugin_gallery_merge['e_table_structure_mismatch'] = 'Source table(s) contain field(s) not in Target - Unable to Merge';
$lang_plugin_gallery_merge['e_invalid_compare_toomany'] = 'Request to compare more than 4 fields not supported';
$lang_plugin_gallery_merge['e_target_duplicate'] = 'Unable to uniquely map %s table - Target gallery has duplicates for Source values'; // %s is table name
$lang_plugin_gallery_merge['e_invalid_merge_table'] = 'Request to merge unsupported table: %s - aborted';                            // %s is table name
$lang_plugin_gallery_merge['e_processing_quiesced'] = 'Processing QUIESCED after %1$u total inserts/updates - %2$u inserts to %3$s'; // %1$u is total inserts; %2$u is table inserts; %3$s is table name
$lang_plugin_gallery_merge['e_missing_plugin_alter'] = 'Plugin in SOURCE that alters CPG Core tables missing from TARGET - Execution aborted';
$lang_plugin_gallery_merge['e_missing_plugin_addtable'] = 'Plugin in SOURCE that add tables with supported merge missing from TARGET - Execution aborted';
$lang_plugin_gallery_merge['e_optional_rebuild_failed'] = 'Unable to rebuild table %s - Optional table used';                        // %s is table name
$lang_plugin_gallery_merge['e_verify_table_missing_data'] = 'Source data missing from Target: %s - verify failed';                   // %s is table name
$lang_plugin_gallery_merge['e_verify_table_aborted'] = 'Verify aborted after %u errors';                                             // %u is error count
$lang_plugin_gallery_merge['e_file_dir_mismatch'] = 'File / Directory mismatch for %s between SOURCE and TARGET';                    // %s is file/directory name
$lang_plugin_gallery_merge['e_userpics_mapping_needs_db'] = 'Unable to complete userpics mapping - complete gallery DB merge and then restart File Merge';
$lang_plugin_gallery_merge['e_invalid_copy_invocation'] = 'Copy function %s called for non-execution run';                           // %s is function name
$lang_plugin_gallery_merge['e_processing_quiesced_files'] = 'Processing QUIESCED after %u files copied';                             // %u is total files
$lang_plugin_gallery_merge['e_verify_files_missing'] = 'Source file(s) missing from Target gallery: - Verify Failed';
$lang_plugin_gallery_merge['e_verify_directories_missing'] = 'Source directory(ies) missing from Target gallery: - Verify Failed';
$lang_plugin_gallery_merge['e_invalid_plugin_custom'] = 'Plugin %s - custom processing requested, but no function(s) provided';      // %s is table constant
$lang_plugin_gallery_merge['e_invalid_plugin_detail'] = 'Plugin %s not found in detail array';                                       // %s is plugin name
// warning messages
$lang_plugin_gallery_merge['w_version_mismatch'] = 'Source and Target at different CPG maintenance level - Execution prevented';
$lang_plugin_gallery_merge['w_version_upgrade'] = 'Upgrade galleries to same maintenance level';
$lang_plugin_gallery_merge['w_version_unknown'] = 'Unable to determine Source maintenance level - Unexpected error';
$lang_plugin_gallery_merge['w_tablename_length'] = 'Backup table name exceeds 64 characters - Execution prevented - adjust \'plugin_gallery_merge_backout_prefix\' in cpg_config';
$lang_plugin_gallery_merge['w_table_structure_mismatch'] = 'Source table(s) contain field(s) not in Target - Execution prevented';
$lang_plugin_gallery_merge['w_unexpected_mapping'] = 'Unexpected mapping result - undefined input and/or output - Execution may have unpredictable results';
$lang_plugin_gallery_merge['w_unexpected_mapping2'] = 'Debug of Summary or higher will provide details';
$lang_plugin_gallery_merge['w_target_duplicate'] = 'Unable to uniquely map %s table - Target gallery has duplicates for Source values'; // %s is table name
$lang_plugin_gallery_merge['w_resolve_duplicate'] = 'Resolve duplicates or change processing from Unique';
$lang_plugin_gallery_merge['w_missing_plugin_alter'] = 'Plugin in SOURCE that alters CPG Core tables missing from TARGET - Execution prevented';
$lang_plugin_gallery_merge['w_missing_plugin_addtable'] = 'Plugin in SOURCE that adds tables with supported merge missing from TARGET - Execution prevented';
$lang_plugin_gallery_merge['w_use_pluginmgr'] = 'Install missing plugin(s) via Plugin Manager';
$lang_plugin_gallery_merge['w_rerun_simulation'] = 'and re-run Simulation';
// information messages
$lang_plugin_gallery_merge['i_userpics_mapping_needs_db'] = 'Gallery contains Userpics folders which requires DB merge to complete to properly map data';
$lang_plugin_gallery_merge['i_userpics_mapping_needs_db2'] = 'File merge execution may still be selected, but will stop in Userpics processing until DB merge is completed';

} // end else
?>