<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

/* page included into admin.php to handle simulate and execution of merges
*/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

// functions and languages already included...

// get sanitized POST parameters
if ($superCage->post->keyExists('submit')) {
    //Check if the form token is valid
    if(!checkFormToken()){
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    // db options
    $plugin_gallery_merge_simulate = FALSE;                                     // default to no DB simulation
    $plugin_gallery_merge_restart_simulate = FALSE;                             // default to no restart DB simulation
    $plugin_gallery_merge_execute = FALSE;                                      // default to no DB execution
    $plugin_gallery_merge_restart_execute = FALSE;                              // default to no restart DB execution
    $plugin_gallery_merge_backout_simulate = FALSE;                             // default to no backout DB simulation
    $plugin_gallery_merge_backout_execute = FALSE;                              // default to no backout DB execution
    $plugin_gallery_merge_backout_emergency = FALSE;                            // default to no emergency backout DB execution
    $plugin_gallery_merge_reset_db = FALSE;                                     // default to no backout DB execution
    // file options
    $plugin_gallery_merge_simulate_files = FALSE;                               // default to no file simulation
    $plugin_gallery_merge_execute_files = FALSE;                                // default to no file execution
    $plugin_gallery_merge_restart_execute_files = FALSE;                        // default to no restart file execution
    $plugin_gallery_merge_reset_files = FALSE;                                  // default to no backout DB execution
    // utility options
    $plugin_gallery_merge_utility_summary = FALSE;                              // default to no execution summary
    $plugin_gallery_merge_utility_execution_detail = FALSE;                     // default to no execution detail
    $plugin_gallery_merge_utility_button_ts = FALSE;                            // default to no ts in button
    $plugin_gallery_merge_utility_checkpoint_detail = FALSE;                    // default to no checkpoint detail
    $plugin_gallery_merge_utility_message_log = FALSE;                          // default to no message log view
    $plugin_gallery_merge_utility_debug_log = FALSE;                            // default to no debug log view
    $plugin_gallery_merge_utility_compare = FALSE;                              // default to no gallery compare
    $plugin_gallery_merge_utility_test_perms = FALSE;                           // default to no test fileperms
    $plugin_gallery_merge_set_offline = FALSE;                                  // default to not set gallery offline
    $plugin_gallery_merge_set_online = FALSE;                                   // default to not set gallery online
    // documentation options
    $plugin_gallery_merge_doc_readme = FALSE;                                   // default to no readme view
    $plugin_gallery_merge_doc_plugin_readme = FALSE;                            // default to no plugin readme view
    $plugin_gallery_merge_doc_plugin_list = FALSE;                              // default to no plugin list view

    if ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['simulate']) {
      $plugin_gallery_merge_simulate = TRUE;                                    // set mode to show simulation DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['restart_simulate']) {
      $plugin_gallery_merge_restart_simulate = TRUE;                            // set mode to show RESTART simulation DB requested
      $plugin_gallery_merge_simulate = TRUE;                                    // set mode to show simulation DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['execute']) {
      $plugin_gallery_merge_execute = TRUE;                                     // set mode to show execute DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['restart_execute']) {
      $plugin_gallery_merge_restart_execute = TRUE;                             // set mode to show RESTART execute DB requested
      $plugin_gallery_merge_execute = TRUE;                                     // set mode to show execute DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['backout_simulate']) {
      $plugin_gallery_merge_backout_simulate = TRUE;                            // set mode to show BACKOUT execute DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['backout_execute']) {
      $plugin_gallery_merge_backout_execute = TRUE;                             // set mode to show BACKOUT execute DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['backout_emergency']) {
      $plugin_gallery_merge_backout_emergency = TRUE;                             // set mode to show BACKOUT execute DB requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['reset_db']) {
      $plugin_gallery_merge_reset_db = TRUE;                                    // set mode to show reset DB requested

    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['simulate_file']) {
      $plugin_gallery_merge_simulate_files = TRUE;                              // set mode to show simulate files requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['execute_file']) {
      $plugin_gallery_merge_execute_files = TRUE;                               // set mode to show execute files requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['restart_execute_file']) {
      $plugin_gallery_merge_restart_execute_files = TRUE;                       // set mode to show RESTART execute files requested
      $plugin_gallery_merge_execute_files = TRUE;                               // set mode to show execute files requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['reset_file']) {
      $plugin_gallery_merge_reset_files = TRUE;                                 // set mode to show reset DB requested

    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_executions']) {
      $plugin_gallery_merge_utility_summary = TRUE;                             // set mode to view executions summary requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_execution_detail']) {
      $plugin_gallery_merge_utility_execution_detail = TRUE;                    // set mode to view execution detail requested
    } elseif (substr($superCage->post->getRaw('submit'), 0, strlen($lang_plugin_gallery_merge['view_timestamp_detail'])) == $lang_plugin_gallery_merge['view_timestamp_detail']) {
      $plugin_gallery_merge_utility_execution_detail = TRUE;                    // set mode to view execution detail requested (alt format with timestamp in submit button)
      $plugin_gallery_merge_utility_button_ts = $superCage->post->getRaw('submit');
    } elseif (substr($superCage->post->getRaw('submit'), 0, strlen($lang_plugin_gallery_merge['view_checkpoint_detail'])) == $lang_plugin_gallery_merge['view_checkpoint_detail']) {
      $plugin_gallery_merge_utility_checkpoint_detail = TRUE;                   // set mode to view checkpoint detail requested (with record id in submit button)
      $plugin_gallery_merge_utility_button_chkptid = $superCage->post->getRaw('submit');
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_message_log']) {
      $plugin_gallery_merge_utility_message_log = TRUE;                         // set mode to view message log requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_debug_log']) {
      $plugin_gallery_merge_utility_debug_log = TRUE;                           // set mode to view message log requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['gallery_compare']) {
      $plugin_gallery_merge_utility_compare = TRUE;                             // set mode to gallery compare requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['test_fileperm']) {
      $plugin_gallery_merge_utility_test_perms = TRUE;                          // set mode to test fileperms requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['set_offline']) {
      $plugin_gallery_merge_set_offline = TRUE;                                 // set mode to test fileperms requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['set_online']) {
      $plugin_gallery_merge_set_online = TRUE;                                  // set mode to test fileperms requested

    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_readme']) {
      $plugin_gallery_merge_doc_readme = TRUE;                                  // set mode to view readme requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_plugin_readme']) {
      $plugin_gallery_merge_doc_plugin_readme = TRUE;                           // set mode to view plugin readme requested
    } elseif ($superCage->post->getRaw('submit') == $lang_plugin_gallery_merge['view_plugin_list']) {
      $plugin_gallery_merge_doc_plugin_list = TRUE;                           // set mode to view plugin readme requested
    }

    // Define the sanitization patterns
    // for merge processing - all input comes from database - already validated in config (admin.php)

    // set up diagnostics
    // error message/flag will halt execution (all modules)
    $plugin_gallery_merge_error = FALSE;                                        // set flag to show no errors
    $plugin_gallery_merge_error_text = array();                                 // set error text to empty array
    // warning message/flag will still continue execution, but prevent marking successful completion (db modules)
    $plugin_gallery_merge_warning = FALSE;                                      // set flag to show no warnings
    $plugin_gallery_merge_warning_text = array();                               // set warning text to empty array
    // info message/flag will still continue execution, and allow successful completion (db and files modules)
    $plugin_gallery_merge_info = FALSE;                                         // set flag to show no info messages
    $plugin_gallery_merge_info_text = array();                                  // set info text to empty array
    $message_level = $CONFIG['plugin_gallery_merge_message_level'];
    $debug_level = $CONFIG['plugin_gallery_merge_debug'];
    $debug_trace = array();
    $debug_error = array();

    // *****************************************************
    // Define Common Variables needed for multiple functions
    // *****************************************************

    // filepath to get to main cpg - used in db and files
    $script_filename = $superCage->env->getRaw('SCRIPT_FILENAME');
    $CONFIG['cpg_filepath'] = str_replace('/index.php', '', $script_filename);

    // array of plugins we may encounter along the way - and their known impacts..
    // additional plugins can be added to the included files array definitions - see comments in included file
    require "./plugins/gallery_merge/data/plugin_data.php";

    if ($plugin_gallery_merge_simulate || $plugin_gallery_merge_execute) {
      // **************************************
      // Include Simulate and Execution DB code
      // **************************************
      require "./plugins/gallery_merge/merge_db.php";
    } // end if simulation or execution of DB merge


    elseif ($plugin_gallery_merge_backout_simulate || $plugin_gallery_merge_backout_execute || $plugin_gallery_merge_backout_emergency) {
      // **********************************************
      // Include Simulate and Execution Backout DB code
      // **********************************************
      require "./plugins/gallery_merge/merge_backout_db.php";
    } // end if simulation or execution of DB backout


    elseif ($plugin_gallery_merge_simulate_files || $plugin_gallery_merge_execute_files) {
      // *****************************************
      // Include Simulate and Execution Files code
      // *****************************************
      require "./plugins/gallery_merge/merge_files.php";
    } // end if simulation or execution of file merge

    elseif ($plugin_gallery_merge_reset_db || $plugin_gallery_merge_reset_files || $plugin_gallery_merge_utility_summary ||
            $plugin_gallery_merge_utility_execution_detail || $plugin_gallery_merge_utility_checkpoint_detail || $plugin_gallery_merge_utility_test_perms ||
            $plugin_gallery_merge_utility_message_log || $plugin_gallery_merge_utility_debug_log || $plugin_gallery_merge_utility_compare ||
            $plugin_gallery_merge_doc_readme || $plugin_gallery_merge_doc_plugin_readme || $plugin_gallery_merge_doc_plugin_list ||
            $plugin_gallery_merge_set_offline || $plugin_gallery_merge_set_online) {
      // **********************
      // Include Utilities code
      // **********************
      require "./plugins/gallery_merge/merge_utility.php";
    } // end if execution of utility functions

} // end if form submission


// display merge section of admin page

//list($timestamp, $form_token) = getFormToken();
// echo <<< EOT
// <form action="index.php?file=gallery_merge/admin" method="post" name="gallery_merge_execution">
// EOT;

// determine which buttons should be active..
// default is to disable those not eligible to run, but config option allows them to be not displayed instead as some themes don't differentiate in displaying disabled buttons
// make s the code much uglier here - but less confusing to those using a theme not handling the disabled attribute (they are still not clickable, but don't display greyed out)
$disable_sim_db = $disable_sim_restart_db = $disable_exec_db = $disable_exec_restart_db = $disable_sim_backout_db = $disable_exec_backout_db = $disable_emergency_backout = $disable_reset_db =
$disable_sim_files = $disable_exec_files = $disable_exec_restart_files = $disable_reset_files = $disable_compare_gallery = $disable_set_offline = $disable_set_online = 'disabled';    // all disabled...
// db operations
if (gallery_merge_validate_option('sim_db')) {
  $disable_sim_db = '';                                                         // db simulation allowed
}
if (gallery_merge_validate_option('sim_restart_db')) {
  $disable_sim_restart_db = '';                                                 // db simulation restart allowed
}
if (gallery_merge_validate_option('exec_db')) {
  $disable_exec_db = '';                                                        // db execution allowed
}
if (gallery_merge_validate_option('exec_restart_db')) {
  $disable_exec_restart_db = '';                                                // db execution restart allowed
}
if (gallery_merge_validate_option('sim_backout_db')) {
  $disable_sim_backout_db = '';                                                 // db backout simulation allowed
}
if (gallery_merge_validate_option('exec_backout_db')) {
  $disable_exec_backout_db = '';                                                // db execution backout allowed
}
if (gallery_merge_validate_option('emergency_backout')) {
  $disable_emergency_backout = '';                                              // emergency backout execution allowed
}
if (gallery_merge_validate_option('reset_db')) {
  $disable_reset_db = '';                                                       // db reset allowed (remove restart info)
}

// file operations
if (gallery_merge_validate_option('sim_files')) {
  $disable_sim_files = '';                                                      // files simulation allowed
}
if (gallery_merge_validate_option('exec_files')) {
  $disable_exec_files = '';                                                     // file execution allowed
}
if (gallery_merge_validate_option('exec_restart_files')) {
  $disable_exec_restart_files = '';                                             // file execution restart allowed
}
if (gallery_merge_validate_option('reset_files')) {
  $disable_reset_files = '';                                                    // files reset allowed (remove restart info)
}

// utility operations
if (gallery_merge_validate_option('compare_gallery')) {
  $disable_compare_gallery = '';                                                // gallery compare
}
if (gallery_merge_validate_option('set_offline')) {
  $disable_set_offline = '';                                                    // gallery offline
}
if (gallery_merge_validate_option('set_online')) {
  $disable_set_online = '';                                                     // gallery online
}

ob_start();                                                                     // buffer output
$button_comment = $lang_plugin_gallery_merge['button_comment'];
if ($CONFIG['plugin_gallery_merge_hide_buttons'] == '1') {
  $button_comment = $lang_plugin_gallery_merge['button_comment_hidden'];
}
starttable('100%', sprintf("{$lang_plugin_gallery_merge['execute_x']} V{$CONFIG['plugin_gallery_merge_version']} ($button_comment)", $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');

if ($register_globals_flag) {
  // we currently have an issue with cpg code if register_globals is ON - a code change required to CPG base to allow access to $GLOBALS
  // test and see if issue exists...
  $plugin_gallery_merge_globals_test1 = $plugin_gallery_merge_globals_test2 = 'variable set';
  if (!gallery_merge_validate_globals()) {
    $data = $lang_plugin_gallery_merge['register_globals_warning'].'<br>'.$lang_plugin_gallery_merge['register_globals_warning2'].'<br>'.$lang_plugin_gallery_merge['register_globals_warning3'];
    msg_box('', $data, '', '', info);
  }
}

echo <<< EOT
    <tr>                                
        <td class="tablef" colspan="3"> 
EOT;

// files options
          if ($disable_sim_files == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['simulate_file']}" $disable_sim_files>{$lang_plugin_gallery_merge['simulate_file']}</button>
EOT;
          }

          if ($disable_exec_files == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['execute_file']}" $disable_exec_files>{$lang_plugin_gallery_merge['execute_file']}</button>
EOT;
          }

          if ($disable_exec_restart_files == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <input type="hidden" name="restart_files_timestamp" value="{$CONFIG['plugin_gallery_merge_ts_exec_files_start']}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['restart_execute_file']}" $disable_exec_restart_files>{$lang_plugin_gallery_merge['restart_execute_file']}</button>
EOT;
          }

// documentation options (always displayed)
echo <<< EOT
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Documentation: &nbsp;&nbsp;
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['view_readme']}" >{$lang_plugin_gallery_merge['view_readme']}</button>

            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['view_plugin_readme']}" >{$lang_plugin_gallery_merge['view_plugin_readme']}</button>

            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['view_plugin_list']}" >{$lang_plugin_gallery_merge['view_plugin_list']}</button>
EOT;

echo <<< EOT
        </td>                                                                                                                                                                                                                
    </tr>                                                                                                                                                                                                                    
    <tr>                                                                                                                                                                                                                     
        <td class="tablef" colspan="3">                                                                                                                                                                                      
EOT;
                                                                                                                                                                                                                             
// DB options
          if ($disable_sim_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['simulate']}" $disable_sim_db>{$lang_plugin_gallery_merge['simulate']}</button>
EOT;
          } else {
            echo "<i>{$lang_plugin_gallery_merge['button_set_config']}</i>";
          }

          if ($disable_sim_restart_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <input type="hidden" name="sim_restart_db_timestamp" value="{$CONFIG['plugin_gallery_merge_ts_sim_db_start']}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['restart_simulate']}" $disable_sim_restart_db>{$lang_plugin_gallery_merge['restart_simulate']}</button>
EOT;
          }

          if ($disable_exec_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['execute']}" $disable_exec_db>{$lang_plugin_gallery_merge['execute']}</button>
EOT;
          }

          if ($disable_exec_restart_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <input type="hidden" name="restart_db_timestamp" value="{$CONFIG['plugin_gallery_merge_ts_exec_db_start']}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['restart_execute']}" $disable_exec_restart_db>{$lang_plugin_gallery_merge['restart_execute']}</button>
EOT;
          }

          if ($disable_sim_backout_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <input type="hidden" name="backout_db_timestamp" value="{$CONFIG['plugin_gallery_merge_ts_exec_db_start']}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['backout_simulate']}" $disable_sim_backout_db>{$lang_plugin_gallery_merge['backout_simulate']}</button>
EOT;
          }

          if ($disable_exec_backout_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <input type="hidden" name="backout_db_timestamp" value="{$CONFIG['plugin_gallery_merge_ts_exec_db_start']}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['backout_execute']}" $disable_exec_backout_db>{$lang_plugin_gallery_merge['backout_execute']}</button>
EOT;
          }

echo <<< EOT
        </td>
    </tr>
    <tr>
        <td class="tablef" colspan="3">
EOT;

// utility options
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['view_executions']}">{$lang_plugin_gallery_merge['view_executions']}</button>

            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['view_execution_detail']}">{$lang_plugin_gallery_merge['view_execution_detail']}</button>
            for timestamp:
            <input type="text" name="execution_detail_timestamp" id="execution_detail_timestamp" class="textinput" size="19" maxlength="19" value="$execution_detail_timestamp" />

            &nbsp;&nbsp;&nbsp;&nbsp;
EOT;

          if ($disable_compare_gallery == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['gallery_compare']}" $disable_compare_gallery>{$lang_plugin_gallery_merge['gallery_compare']}</button>
EOT;
          }

echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['test_fileperm']}" >{$lang_plugin_gallery_merge['test_fileperm']}</button>
EOT;

          if ($disable_reset_files == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['reset_file']}" $disable_reset_files>{$lang_plugin_gallery_merge['reset_file']}</button>
EOT;
          }

          if ($disable_reset_db == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['reset_db']}" $disable_reset_db>{$lang_plugin_gallery_merge['reset_db']}</button>
EOT;
          }

          if ($disable_set_offline == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['set_offline']}" $disable_set_offline>{$lang_plugin_gallery_merge['set_offline']}</button>
EOT;
          }

          if ($disable_set_online == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['set_online']}" $disable_set_online>{$lang_plugin_gallery_merge['set_online']}</button>
EOT;
          }

          if ($disable_emergency_backout == '' || $CONFIG['plugin_gallery_merge_hide_buttons'] == '0') {
echo <<< EOT
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gallery_merge['backout_emergency']}" $disable_emergency_backout>{$lang_plugin_gallery_merge['backout_emergency']}</button>
EOT;
          }

echo <<< EOT
        </td>
    </tr>
EOT;
endtable();

$button_html = ob_get_flush();                                                  // flush (send) buffer and retain
// if debug - and debug arrays have contents... put them out...
if (($CONFIG['plugin_gallery_merge_debug']) && (count($debug_trace) > 0)) {
  starttable('100%', sprintf($lang_plugin_gallery_merge['debug_results'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
  foreach ($debug_trace AS $trace) {
      gallery_merge_output_status('blank', $trace, 'debug');
  }
  endtable();
  // typically a lot of debug output... redisplay results and buttons if so
  if (count($debug_trace) > '30') {
    echo $results_html;                                                           // redisplay results after debug
    echo $button_html;                                                            // redisplay buttons after debug
  }
}
echo <<< EOT
</form>
EOT;
gallery_merge_output_status('', '', 'close');
?>