<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

/* page included into admin.php to handle utility views
*/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

      // ***************************
      // Utility code starts here...
      // ***************************
      if ($plugin_gallery_merge_reset_db) {
        $plugin_gallery_merge_modetext = 'execution';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_reset_db_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      } elseif ($plugin_gallery_merge_reset_files) {
        $plugin_gallery_merge_modetext = 'execution';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_reset_files_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      } elseif ($plugin_gallery_merge_utility_summary || $plugin_gallery_merge_utility_execution_detail || $plugin_gallery_merge_utility_checkpoint_detail ||
                $plugin_gallery_merge_utility_message_log || $plugin_gallery_merge_utility_debug_log) {
        $plugin_gallery_merge_modetext = 'display';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_view_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      } elseif ($plugin_gallery_merge_utility_compare) {
        $plugin_gallery_merge_modetext = 'compare';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_compare_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      } elseif ($plugin_gallery_merge_utility_test_perms) {
        $plugin_gallery_merge_modetext = 'testperm';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_testperm_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      } elseif ($plugin_gallery_merge_set_offline || $plugin_gallery_merge_set_online) {
        $plugin_gallery_merge_modetext = 'setstatus';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_setstatus_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      } elseif ($plugin_gallery_merge_doc_readme || $plugin_gallery_merge_doc_plugin_readme || $plugin_gallery_merge_doc_plugin_list) {
        $plugin_gallery_merge_modetext = 'viewdoc';
        starttable('100%', sprintf($lang_plugin_gallery_merge['utility_doc_view_title'], $lang_plugin_gallery_merge['plugin_name']), 3, 'cpg_zebra');
      }

      // *********************
      // Reset DB Config Stats
      // *********************
      // reset all DB timestamps in $CONFIG database - disables all backouts/restarts
      $process_constant = 'UTILITY_RESET_DB';
      if ($plugin_gallery_merge_reset_db) {
        $col1 = $lang_plugin_gallery_merge['utility_reset_db'];
        $col2 = $lang_plugin_gallery_merge['utility_reset_db_comment'];
        gallery_merge_output_status($col1, $col2);
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:INITIATED");
        // clear all timestamp flags in $CONFIG and cpg_config table...
        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET `value` = '0000-00-00 00:00:00' WHERE `name` LIKE 'plugin_gallery_merge_ts_%_db_%'");
        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET `value` = '0000-00-00 00:00:00' WHERE `name` LIKE 'plugin_gallery_merge_ts_%_dbbko_%'");
        $CONFIG['plugin_gallery_merge_ts_sim_db_start'] = $CONFIG['plugin_gallery_merge_ts_sim_db_end'] = $CONFIG['plugin_gallery_merge_ts_sim_db_warn'] = $CONFIG['plugin_gallery_merge_ts_exec_db_start'] = $CONFIG['plugin_gallery_merge_ts_exec_db_end'] = '0000-00-00 00:00:00';
        $CONFIG['plugin_gallery_merge_ts_sim_dbbko_start'] = $CONFIG['plugin_gallery_merge_ts_sim_dbbko_end'] = $CONFIG['plugin_gallery_merge_ts_exec_dbbko_start'] = $CONFIG['plugin_gallery_merge_ts_exec_dbbko_end'] = '0000-00-00 00:00:00';
        $col2 = "{$lang_plugin_gallery_merge['utility_reset_db_complete']}";
        gallery_merge_output_status('blank', $col2);
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:COMPLETED");
      }

      // ************************
      // Reset Files Config Stats
      // ************************
      // reset all Files timestamps in $CONFIG database - disables all restarts
      $process_constant = 'UTILITY_RESET_FILES';
      if ($plugin_gallery_merge_reset_files) {
        $col1 = $lang_plugin_gallery_merge['utility_reset_files'];
        $col2 = $lang_plugin_gallery_merge['utility_reset_files_comment'];
        gallery_merge_output_status($col1, $col2);
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:INITIATED");
        // clear all timestamp flags in $CONFIG and cpg_config table...
        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET `value` = '0000-00-00 00:00:00' WHERE `name` LIKE 'plugin_gallery_merge_ts_%_files_%'");
        $CONFIG['plugin_gallery_merge_ts_sim_files_start'] = $CONFIG['plugin_gallery_merge_ts_sim_files_end'] = $CONFIG['plugin_gallery_merge_ts_exec_files_start'] = $CONFIG['plugin_gallery_merge_ts_exec_files_end'] = '0000-00-00 00:00:00';
        $col2 = "{$lang_plugin_gallery_merge['utility_reset_files_complete']}";
        gallery_merge_output_status('blank', $col2);
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:COMPLETED");
      }

      // *******************
      // Set Gallery Offline
      // *******************
      // update config to set gallery offline
      $process_constant = 'UTILITY_SET_OFFLINE';
      if ($plugin_gallery_merge_set_offline) {
        $col1 = $lang_plugin_gallery_merge['utility_set_offline'];
        $col2 = $lang_plugin_gallery_merge['utility_set_offline_comment'];
        gallery_merge_output_status($col1, $col2);
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:INITIATED");
        // make it so...
        gallery_merge_offline('offline');
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:COMPLETED");
      }

      // ******************
      // Set Gallery Online
      // ******************
      // update config to set gallery online
      $process_constant = 'UTILITY_SET_ONLINE';
      if ($plugin_gallery_merge_set_online) {
        $col1 = $lang_plugin_gallery_merge['utility_set_online'];
        $col2 = $lang_plugin_gallery_merge['utility_set_online_comment'];
        gallery_merge_output_status($col1, $col2);
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:INITIATED");
        // make it so...
        gallery_merge_offline('online');
        gallery_merge_checkpoint('util', 'checkpoint', '', "$process_constant:COMPLETED");
      }

      // **********************
      // View Execution Summary
      // **********************
      $process_constant = 'UTILITY_EXECUTION_SUMMARY';
      if ($plugin_gallery_merge_utility_summary) {
        $col1 = $lang_plugin_gallery_merge['utility_execution_summary'];
        $col2 = $lang_plugin_gallery_merge['utility_execution_summary_comment'];
        gallery_merge_output_status($col1, $col2);
        $sql = "SELECT * FROM {$CONFIG['TABLE_RESTART']} WHERE text LIKE '%:INITIATED' ORDER BY id DESC";
        $result = cpg_db_query($sql);
        while ($row = cpg_db_fetch_row($result)) {
          // extract data
          $checkpoint =  explode(':', $row['text']);
          $process_constant = $checkpoint[0];                                   // target table name if first word of checkpoint text
          $process_name = strtolower($process_constant);                         // lowercase table constant for messages
          $process_status = $checkpoint[1];
          // write it out
          $button = "<button type=\"submit\" class=\"button\" name=\"submit\" value=\"{$lang_plugin_gallery_merge['view_timestamp_detail']} {$row['timestamp']}\">{$lang_plugin_gallery_merge['view_timestamp_detail']} {$row['timestamp']}</button>";
          $col2 = "$button - {$lang_plugin_gallery_merge[$process_name]} {$lang_plugin_gallery_merge['started']}";
          gallery_merge_output_status('blank', $col2);
        }
      cpg_db_free_result($result);
      $col2 = $lang_plugin_gallery_merge['utility_execution_summary_complete'];
      gallery_merge_output_status('blank', $col2);
      }

      // *********************
      // View Execution Detail
      // *********************
      $process_constant = 'UTILITY_EXECUTION_DETAIL';
      if ($plugin_gallery_merge_utility_execution_detail) {
        $execution_detail_timestamp = FALSE;
        if (!$plugin_gallery_merge_utility_button_ts) {
          // normal main menu format with timestamp in separate variable...
          $execution_detail_timestamp = trim($superCage->post->getRaw('execution_detail_timestamp'));   // used ONLY for select
        } else {
          // alternate format with timestamp imbedded in submit button - extract... (string followed by space - so no need to decrement strlen result)
          $execution_detail_timestamp = trim(substr($plugin_gallery_merge_utility_button_ts, strlen($lang_plugin_gallery_merge['view_timestamp_detail'])));   // used ONLY for select
        }
        if ($execution_detail_timestamp) {
          $col1 = $lang_plugin_gallery_merge['utility_execution_detail'];
          $col2 = sprintf($lang_plugin_gallery_merge['utility_execution_detail_comment'], $execution_detail_timestamp);
          gallery_merge_output_status($col1, $col2);

          // see if we have a message logfile
          $file_starttime = (str_replace(' ', '_', $execution_detail_timestamp));
          $file_starttime = (str_replace(':', '-', $file_starttime));
          $message_filepath = $CONFIG['cpg_filepath']."/plugins/gallery_merge/logs/message_{$file_starttime}.html";
          if (file_exists($message_filepath)) {
            $button = "<button type=\"submit\" class=\"button\" name=\"submit\" value=\"{$lang_plugin_gallery_merge['view_message_log']}\">{$lang_plugin_gallery_merge['view_message_log']}</button>";
            // write it out
            $col2 = "{$button}";
            gallery_merge_output_status('blank', $col2);
          }
          $sql = "SELECT * FROM {$CONFIG['TABLE_RESTART']} WHERE timestamp = '$execution_detail_timestamp' ORDER BY id";
          $result = cpg_db_query($sql);
          while ($row = cpg_db_fetch_row($result)) {
            // extract data
            $checkpoint =  explode(':', $row['text']);
            $process_constant = $checkpoint[0];                                   // target table name if first word of checkpoint text
            $process_status = $checkpoint[1];
            $trail = '';
            if ($process_status == 'COPIED') {
              // $checkpoint[2] contains number of files
              // $checkpoint[3] contains 'LASTKEY'
              // $checkpoint[4] contains last folder processed
              $trail = sprintf($lang_plugin_gallery_merge['utility_execution_detail_file_count'], $checkpoint[2], $checkpoint[4]);
            } elseif ($process_status == 'INSERTED') {
              // $checkpoint[2] contains number of records
              // $checkpoint[3] contains 'LASTKEY'
              // $checkpoint[4] contains last key processed
              $trail = sprintf($lang_plugin_gallery_merge['utility_execution_detail_insert_count'], $checkpoint[2], $checkpoint[4]);
            } elseif ($process_status == 'QUIESCE') {
              // $checkpoint[2] contains number of records/files
              // $checkpoint[3] contains 'LASTKEY'
              // $checkpoint[4] contains last key/folder processed
              $trail = sprintf($lang_plugin_gallery_merge['utility_execution_detail_quiesce_point'], $checkpoint[4]);
            }
            $button = '';
            if ($row['data'] != '') {
              $button = "<button type=\"submit\" class=\"button\" name=\"submit\" value=\"{$lang_plugin_gallery_merge['view_checkpoint_detail']} {$row['id']}\">{$lang_plugin_gallery_merge['view_checkpoint_detail']}</button>";
            }
            // write it out
            $col2 = "{$process_constant} - {$process_status} {$trail} {$button}";
            gallery_merge_output_status('blank', $col2);
          }
          cpg_db_free_result($result);

          // see if we have database backups
          $backup_timestamp = str_replace(' ', '_', $execution_detail_timestamp); // remove spaces in timestamp
          $backup_table_prefix = "{$CONFIG['TABLE_PREFIX']}{$CONFIG['plugin_gallery_merge_backout_prefix']}{$backup_timestamp}_";
          $result = cpg_db_query("SHOW FULL TABLES LIKE '{$backup_table_prefix}%'");
          $rowset = cpg_db_fetch_rowset($result);
          cpg_db_free_result($result);
          $table_list = '';
          foreach ($rowset AS $row) {
            $tablearray = each ($row );                                         // don't know the key - contains DBNAME and LIKE criteria - so use each to extract value
            $tablename = str_replace($backup_table_prefix, '', $tablearray['value']); // extract table name
            $tabletype = $row['Table_type'];                                    // we know the key for the type... BASE TABLE or VIEW
            $result = cpg_db_query("SELECT COUNT( * ) FROM `{$tablearray['value']}`");
            $backup_count = cpg_db_result($result, 0, 0);
            cpg_db_free_result($result);
            $table_list .= sprintf($lang_plugin_gallery_merge['utility_execution_backups_list'], $tablename, $backup_count).'<br />';
          }
          if ($table_list != '') {
            $col2 = "{$lang_plugin_gallery_merge['utility_execution_backups']}: <br />$table_list";
            gallery_merge_output_status('blank', $col2);
          } else {
            $col2 = $lang_plugin_gallery_merge['utility_execution_backups_none'];
            gallery_merge_output_status('blank', $col2);
          }

          // see what other logfiles we might have
          $debug_filepath = $CONFIG['cpg_filepath']."/plugins/gallery_merge/logs/debug_{$file_starttime}.html";
          $sql_filepath = $CONFIG['cpg_filepath']."/plugins/gallery_merge/logs/log_{$file_starttime}.sql";

          if (file_exists($sql_filepath)) {
            $log_htmlpath = str_replace($CONFIG['cpg_filepath'], $CONFIG['ecards_more_pic_target'], $sql_filepath);
            $col1 = "&nbsp;";
            $col2 = "<a href=\"$sql_htmlpath\">{$lang_plugin_gallery_merge['utility_execution_sql_view']}</a>";;
            gallery_merge_output_status($col1, $col2);
          } else {
            $col2 = $lang_plugin_gallery_merge['utility_execution_sql_none'];
            gallery_merge_output_status('blank', $col2);
          }

          if (file_exists($debug_filepath)) {
            $button = "<button type=\"submit\" class=\"button\" name=\"submit\" value=\"{$lang_plugin_gallery_merge['view_debug_log']}\">{$lang_plugin_gallery_merge['view_debug_log']}</button>";
            // write it out
            $col2 = "{$button}";
            gallery_merge_output_status('blank', $col2);
          }

        } else {
          $col1 = $lang_plugin_gallery_merge['utility_execution_detail'];
          $col2 = $lang_plugin_gallery_merge['utility_execution_detail_no_ts'];
          gallery_merge_output_status($col1, $col2);
        }
      $col2 = $lang_plugin_gallery_merge['utility_execution_detail_complete'];
      gallery_merge_output_status('blank', $col2);
      }

      // **********************
      // View Checkpoint Detail
      // **********************
      $process_constant = 'UTILITY_CHECKPOINT_DETAIL';
      if ($plugin_gallery_merge_utility_checkpoint_detail) {
        $checkpoint_detail_id = substr($plugin_gallery_merge_utility_button_chkptid, strlen($lang_plugin_gallery_merge['view_checkpoint_detail']));   // used ONLY for select
        $execution_detail_timestamp = trim($superCage->post->getRaw('execution_detail_timestamp'));   // used ONLY for select - put back into form to allow easy access to execution timestamp detail

        $checkpoint_data = gallery_merge_checkpoint_load_id($checkpoint_detail_id);
        $col1 = $lang_plugin_gallery_merge['utility_checkpoint_detail'];
        if (is_array($checkpoint_data)) {
          $col2 = '<pre>CHECKPOINT '.print_r($checkpoint_data, TRUE).'</pre>';
        } else {
          $col2 = $lang_plugin_gallery_merge['utility_checkpoint_detail_none'];
        }
        gallery_merge_output_status($col1, $col2);
      }

      // *************************
      // View Message or Debug Log
      // *************************
      $process_constant = 'UTILITY_MESSAGE_LOG_VIEW';
      if ($plugin_gallery_merge_utility_message_log || $plugin_gallery_merge_utility_debug_log) {
        $execution_detail_timestamp = trim($superCage->post->getRaw('execution_detail_timestamp'));   // used ONLY for select - put back into form to allow easy access to execution timestamp detail
        // set up logfile name
        $file_starttime = (str_replace(' ', '_', $execution_detail_timestamp));
        $file_starttime = (str_replace(':', '-', $file_starttime));
        if ($plugin_gallery_merge_utility_message_log) {
          $logname = $lang_plugin_gallery_merge['utility_log_message'];
        } else {
          $logname = $lang_plugin_gallery_merge['utility_log_debug'];
        }
        $col1 = sprintf($lang_plugin_gallery_merge['utility_log'], $logname, $execution_detail_timestamp);
        gallery_merge_output_status($col1, 'blank', 'heading');
        $filepath = $CONFIG['cpg_filepath']."/plugins/gallery_merge/logs/{$logname}_{$file_starttime}.html";
        if (file_exists($filepath)) {
          $filehandle = fopen($filepath, 'r');
          if (!$filehandle) {
            $col1 = sprintf($lang_plugin_gallery_merge['utility_log_view'], $logname);
            $col2 = $lang_plugin_gallery_merge['utility_log_not_found'];
            gallery_merge_output_status($col1, $col2);
          } else {
            while ($message = fgets($filehandle)) {
              echo $message;
            }
            fclose($filehandle);
          }
        }
      }

      // ***************
      // Gallery Compare
      // ***************
      // intended as post merge compare - the comparison logic expects minimal differences between galleries (unlike simulation that expects minimal conflicts
      // processes file and/or db compare based on which executions have completed since last config change
      $process_constant = 'UTILITY_GALLERY_COMPARE';
      if ($plugin_gallery_merge_utility_compare) {
        // Obtain Source Connection Info
        if (!$plugin_gallery_merge_error) {
          $SOURCE = array();
          gallery_merge_obtain_source_config();
        }
        if (!$plugin_gallery_merge_error) {
          $col1 = "{$lang_plugin_gallery_merge["$plugin_gallery_merge_modetext"]} {$lang_plugin_gallery_merge['started']}";
          gallery_merge_output_status($col1, 'blank');
        }
        // Validate/Connect to SOURCE Database
        if (!$plugin_gallery_merge_error) {
          gallery_merge_connect_source();
        }
        // Initialize Variables
        if (!$plugin_gallery_merge_error) {
          // Set up all SOURCE table names we may need (adapted from init.inc.php)
          // array already started above
          $SOURCE['TABLE_CONFIG']        = $SOURCE['TABLE_PREFIX'].'config';
          $SOURCE['TABLE_PICTURES']      = $SOURCE['TABLE_PREFIX'].'pictures';
          $SOURCE['TABLE_ALBUMS']        = $SOURCE['TABLE_PREFIX'].'albums';
          $SOURCE['TABLE_CATEGORIES']    = $SOURCE['TABLE_PREFIX'].'categories';
          $SOURCE['TABLE_USERGROUPS']    = $SOURCE['TABLE_PREFIX'].'usergroups';
          $SOURCE['TABLE_USERS']         = $SOURCE['TABLE_PREFIX'].'users';
          // get albums folder filepath for SOURCE and TARGET...
          // Retrieve SOURCE DB stored configuration - and compare to TARGET
          $result = cpg_db_query("SELECT name, value FROM {$SOURCE['TABLE_CONFIG']} WHERE name = 'fullpath' LIMIT 1", $SOURCE['LINK_ID']);
          $source_row = cpg_db_fetch_row($result);
          $SOURCE['fullpath'] = $source_row['value'];
          $SOURCE['album_filepath'] = $CONFIG['plugin_gallery_merge_source_filepath'].'/'.rtrim($SOURCE['fullpath'], '/');
          // $CONFIG['cpg_filepath'] set in merge.php
          $CONFIG['album_filepath'] = $CONFIG['cpg_filepath'].'/'.rtrim($CONFIG['fullpath'], '/');
          $CONFIG['album_filepath_add'] = $CONFIG['cpg_filepath'].'/'.$CONFIG['fullpath'].rtrim($CONFIG['plugin_gallery_merge_add_subfolder'], '/');
          // compare values needed for handling remove/add folder requests
          $SOURCE['compare_remove'] = "{$SOURCE['album_filepath']}/{$CONFIG['plugin_gallery_merge_remove_subfolder']}";              // substring match for directories beginning with...
          $SOURCE['compare_remove_len'] = strlen($SOURCE['compare_remove']);      // length for compare
          $SOURCE['compare_remove2'] = "{$SOURCE['album_filepath']}/".rtrim($CONFIG['plugin_gallery_merge_remove_subfolder'], '/');  // exact match for directory
          $SOURCE['compare_userpics'] = "{$SOURCE['album_filepath']}/{$CONFIG['userpics']}";  // substring match for directories beginning with...
          $SOURCE['compare_userpics_len'] = strlen($SOURCE['compare_userpics']);  // length for compare
          $SOURCE['compare_userpics2'] = "{$SOURCE['album_filepath']}/".rtrim($CONFIG['userpics'], '/');  // exact match for directory
        }

        // *********************************************
        // Compare Directories/Files to Validate Results
        // *********************************************
        if (!$plugin_gallery_merge_error && gallery_merge_validate_option('compare_files')) {
          // compare directories/files - report exceptions only
          $col1 = $lang_plugin_gallery_merge['verify_files'];
          $col2 = $lang_plugin_gallery_merge['utility_compare_files_comment'];
          gallery_merge_output_status($col1, $col2);
          gallery_merge_verify_files('all');
          if (!$plugin_gallery_merge_error) {
            $col2 = $lang_plugin_gallery_merge['utility_compare_files_complete'];
            gallery_merge_output_status('blank', $col2);
          }
        }

        if (!gallery_merge_validate_option('compare_files')) {
          $col1 = $lang_plugin_gallery_merge['verify_files'];
          $col2 = $lang_plugin_gallery_merge['utility_compare_files_bypass'];
          gallery_merge_output_status($col1, $col2);
        }

        // *********************************************
        // Process Remaining CPG Files for Discrepancies
        // *********************************************
        if (!$plugin_gallery_merge_error && gallery_merge_validate_option('compare_files')) {
          // compare directories - outputting information on missing target directories
          $col1 = $lang_plugin_gallery_merge['compare_cpg'];
          $col2 = $lang_plugin_gallery_merge['utility_compare_files_cpg_comment'];
          gallery_merge_output_status($col1, $col2);
          $col2 = $lang_plugin_gallery_merge['utility_compare_files_cpg_comment2'];
          gallery_merge_output_status('blank', $col2);
          gallery_merge_compare_cpg($CONFIG['plugin_gallery_merge_source_filepath']);
          if (!$plugin_gallery_merge_error) {
            gallery_merge_checkpoint('files', 'checkpoint', '', "$process_constant:COMPLETE");
            $col2 = $lang_plugin_gallery_merge['utility_compare_files_cpg_complete'];
            gallery_merge_output_status('blank', $col2);
          }
        }

        if (!gallery_merge_validate_option('compare_files')) {
          $col1 = $lang_plugin_gallery_merge['compare_cpg'];
          $col2 = $lang_plugin_gallery_merge['utility_compare_files_bypass'];
          gallery_merge_output_status($col1, $col2);
        }

        // *****************************
        // Compare DB tables to validate
        // *****************************
        // execution mode only... nothing different than above if simulation
        if (!$plugin_gallery_merge_error && gallery_merge_validate_option('compare_db')) {
          $col1 = $lang_plugin_gallery_merge['utility_compare_db'];
          $col2 = $lang_plugin_gallery_merge['utility_compare_db_comment'];
          gallery_merge_output_status($col1, $col2);
          // for each table updated during merge - and containing a value we can compare... compare to see that all in SOURCE made it to TARGET
          gallery_merge_verify_table('TABLE_USERGROUPS', 'group_name');
          gallery_merge_verify_table('TABLE_USERS', 'user_name');
          gallery_merge_verify_table('TABLE_CATEGORIES', 'name');
          gallery_merge_verify_table('TABLE_ALBUMS', 'title');
          gallery_merge_verify_table('TABLE_PICTURES', 'filename', 'filepath');
          if (!$plugin_gallery_merge_error) {
            $col2 = $lang_plugin_gallery_merge['utility_compare_db_complete'];
            gallery_merge_output_status('blank', $col2);
          }
        }

        if (!gallery_merge_validate_option('compare_db')) {
          $col1 = $lang_plugin_gallery_merge['utility_compare_db'];
          $col2 = $lang_plugin_gallery_merge['utility_compare_db_bypass'];
          gallery_merge_output_status($col1, $col2);
        }

      } // end gallery compare

      // ****************
      // Test Permissions
      // ****************
      // To validate config permission settings and be sure they product the desired result...
      // Several sample folders/files copied to
      $process_constant = 'UTILITY_TEST_PERMISSIONS';
      if ($plugin_gallery_merge_utility_test_perms) {
        // $CONFIG['cpg_filepath'] already set in merge.php to point to cpg root directory with no trailing slash
        // need to create folders in the albums directory because permissions can be inheritted.
        // last added gallery pic thumbnail will be used for the pic copy
        $col1 = $lang_plugin_gallery_merge['utility_perms'];
        $col2 = $lang_plugin_gallery_merge['utility_perms_comment'];
        gallery_merge_output_status($col1, $col2);
        $album_filepath = $CONFIG['cpg_filepath'].'/'.$CONFIG['fullpath'];
        $dest1 = $album_filepath.'gallery_merge_cpgdefault_perms';
        $dest2 = $album_filepath.'gallery_merge_source_perms';
        $dest3 = $album_filepath.'gallery_merge_specified_perms';
        $dest4 = $album_filepath.'gallery_merge_default_perms';
        $result = cpg_db_query("SELECT filepath, filename FROM `{$CONFIG['TABLE_PICTURES']}` ORDER BY pid DESC LIMIT 1");
        $row = cpg_db_fetch_row($result);
        cpg_db_free_result($result);
        $src_file = $CONFIG['thumb_pfx'].$row['filename'];
        $srcfolder = $album_filepath.rtrim($row['filepath'], '/');
        $srcfilepath = $album_filepath.$row['filepath'].$src_file;
        if (file_exists($dest1) || file_exists($dest2) || file_exists($dest3) || file_exists($dest4)) {
          $col2 = "{$lang_plugin_gallery_merge['utility_perms_test_folders_exist']}:<br>
                   - $dest1<br>
                   - $dest2<br>
                   - $dest3<br>
                   - $dest4<br>
                   {$lang_plugin_gallery_merge['utility_perms_test_folders_exist2']}";
          gallery_merge_output_status('blank', $col2);
        } else {
          $col2 = sprintf($lang_plugin_gallery_merge['utility_perms_create_folder_cpgdefault'], $dest1, $CONFIG['default_dir_mode']).'<br>'.
                  sprintf($lang_plugin_gallery_merge['utility_perms_create_folder_source'], $dest2, $album_filepath).'<br>'.
                  sprintf($lang_plugin_gallery_merge['utility_perms_create_folder_specified'], $dest3, $CONFIG['plugin_gallery_merge_folder_perm_value']).'<br>'.
                  sprintf($lang_plugin_gallery_merge['utility_perms_create_folder_default'], $dest1).'<br>';
          gallery_merge_output_status('blank', $col2);
          // cpg config default
          mkdir($dest1, octdec($CONFIG['default_dir_mode']));
          // source permissions
          mkdir($dest2, fileperms($album_filepath));
          // specified permissions
          mkdir($dest3, octdec($CONFIG['plugin_gallery_merge_folder_perm_value']));
          // default...
          mkdir($dest4);

          if (!file_exists($srcfilepath)) {
            $col2 = sprintf($lang_plugin_gallery_merge['utility_perms_file_not_found'], $srcfilepath);
            gallery_merge_output_status('blank', $col2);
          } else {
            $col2 = sprintf($lang_plugin_gallery_merge['utility_perms_create_file'], $srcfilepath).':<br>'.
                    sprintf($lang_plugin_gallery_merge['utility_perms_create_file_cpgdefault'], "$dest1/$src_file", $CONFIG['default_file_mode']).'<br>'.
                    sprintf($lang_plugin_gallery_merge['utility_perms_create_file_source'], "$dest2/$src_file", $srcfilepath).'<br>'.
                    sprintf($lang_plugin_gallery_merge['utility_perms_create_file_specified'], "$dest3/$src_file", $CONFIG['plugin_gallery_merge_file_perm_value']).'<br>'.
                    sprintf($lang_plugin_gallery_merge['utility_perms_create_file_default'], "$dest4/$src_file").'<br>';
            gallery_merge_output_status('blank', $col2);
            // default...
            copy($srcfilepath, $dest1.'/'.$src_file);
            chmod($dest3.'/'.$src_file, octdec($CONFIG['default_file_mode']));
            // source permissions
            copy($srcfilepath, $dest2.'/'.$src_file);
            chmod($dest2.'/'.$src_file, fileperms($srcfilepath));
            // specified permissions
            copy($srcfilepath, $dest3.'/'.$src_file);
            chmod($dest3.'/'.$src_file, octdec($CONFIG['plugin_gallery_merge_file_perm_value']));
            // default...
            copy($srcfilepath, $dest4.'/'.$src_file);
          }
        }
        $col2 = "{$lang_plugin_gallery_merge['utility_perms_result']}<br>
                 {$lang_plugin_gallery_merge['utility_perms_result2']}";
        gallery_merge_output_status('blank', $col2);
      }

      // ******************
      // View Documentation
      // ******************
      // To validate config permission settings and be sure they product the desired result...
      // Several sample folders/files copied to
      $process_constant = 'DOCUMENTATION VIEW';
      if ($plugin_gallery_merge_doc_readme) {
        include ('./plugins/gallery_merge/readme.php');
      }
      if ($plugin_gallery_merge_doc_plugin_readme) {
        include ('./plugins/gallery_merge/readme_plugin_support.php');
      }
      if ($plugin_gallery_merge_doc_plugin_list) {
        // little more effort here - as we need to process plugin data to generate output
        echo <<< EOT
          <tr>
            <td colspan=3>
              <h2>
              {$lang_plugin_gallery_merge['plugin_name']} - {$lang_plugin_gallery_merge['utility_plugin_defined_supported']}:
              </h2>
            </td>
          </tr>
          <tr>
            <td>{$lang_plugin_gallery_merge['utility_plugin_name']}<br>({$lang_plugin_gallery_merge['utility_plugin_version']})</td>
            <td>{$lang_plugin_gallery_merge['utility_plugin_details']}</td>
          </tr>
EOT;
        // plugin data already loaded by merge.php - $plugin_array populated
        foreach ($plugin_array as $plugin_folder => $plugin_detail) {
          // plugin folder is $plugin_folder
          // plugin version is $plugin_detail['version']
          // construct detail:
          if ($plugin_detail['merge_script'] == 'n/a') {
            $detail = $lang_plugin_gallery_merge['utility_plugin_no_data_impact'].'<br>';
          } elseif (($plugin_detail['merge_script'] == '') || ($plugin_detail['merge_script'] == 'needed')) {
            $detail = $lang_plugin_gallery_merge['utility_plugin_data_merge_required'].'<br>';
          } else {
            $detail = $lang_plugin_gallery_merge['utility_plugin_data_merge_supported'].'<br>';
          }
          if ($plugin_detail['alters_cpg_tables']) {
            $detail .= $lang_plugin_gallery_merge['utility_plugin_alters_cpg_tables'].'<br>';
          }
          if ($plugin_detail['adds_tables']) {
            $detail .= $lang_plugin_gallery_merge['utility_plugin_adds_tables'].'<br>';
          }
          if ($plugin_detail['standard_folders']) {
            $detail .= 'Folder name: plugins/'.$plugin_folder;
          } else {
            $detail .= 'Folder name: '.$plugin_folder;
          }
          if ($plugin_detail['table_pattern']) {
            $detail .= ' - Table pattern: '.$plugin_detail['table_pattern'];
          }
          echo <<< EOT
            <tr>
              <td>{$plugin_detail['name']}<br>({$plugin_detail['version']})</td>
              <td>$detail</td>
            </tr>
EOT;
        } // end foreach
      }

      // *************
      // Output Status
      // *************
      ob_start();
      echo <<< EOT
        <tr>
          <td class="tablef" colspan="2" >
EOT;
      if ($plugin_gallery_merge_error) {
        gallery_merge_error_output('error');
      } else {
        gallery_merge_error_output('success');
      }
      echo <<< EOT
          </td>
        </tr>
EOT;
      $results_html = ob_get_flush();                                           // flush (send) buffer and retain
      // all done!!!
      endtable();
?>