<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

if (!defined('IN_COPPERMINE')) {
  // allow direct display - add necessary html
  echo <<< EOT
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
    <head>
        <title>Gallery Merge Readme</title>
        <link rel="stylesheet" href="../../css/coppermine.css" type="text/css" />
        <link rel="stylesheet" href="../../themes/curve/style.css" type="text/css" />
        <script src="docs/js/jquery.js" type="text/javascript"></script>
        <script src="docs/js/help.js" type="text/javascript"></script>
    </head>
    <body>
        <div id="cpg_main_block">
          <p>&nbsp;<p>
          <table align="center" width="100%" cellspacing="1" cellpadding="0" class="maintable cpg_zebra">
            <tr>
                <td class="" colspan="3">
                    <div class="cpg_starttable_outer">
                        <div class="cpg_starttable_inner">
                            View Documentation
                        </div>
                    </div>
                </td>
            </tr>
EOT;
}

echo <<< EOT
  <tr>
    <td colspan=3>
      <h2>
      Gallery Merge Documentation:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

See readme.php (or readme.txt) for documentation on main Gallery Merge Plugin.<br>
This file describes support for Gallery Merge to process data tables from other plugins during a merge.

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Gallery Merge Plugin Support for Other Plugin's Data:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Of course there are many plugins available for use with CPG, and many of them need consideration during Gallery Merge.<br>
Those that add features without altering the structure of CPG tables (adding columns, etc) or without adding their own CPG tables can often be
addressed just by insuring the same plugin in installed in the Target gallery.<br>
However, those that alter the structure of CPG tables, or add their own tables, have other considerations.
<p>
Those altering structure MUST be installed in the target gallery, or our generated SQL to merge galleries will not match the structure of the
Target table. (Even if SQL were generated to account for this difference - you would lose the data in the altered fields..)<br>
Those adding their own tables may need to have that data either compared with Target or Migrated.<br>
Plugins may also just add rows to the CPG Config table - these are typically addressed just by installed the plugin in the Target if not already there.
Exceptions here will be noted in both the compare of the Config table, and the compare of installed plugins.
<p>
During Merge simulation and execution, the plugins installed in the Source galery will be matched to the Target, and our knowledge base. Exceptions will be noted.
Critical exceptions (plugins missing that are known to ALTER CPG tables) will flag a warning and prevent execution.

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Plugin Knowledge Base:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Obviously I don't know about all plugins, nor could I possibly research them all... but you can help! An interface is provided to allow easy addition of knowledge about other plugins,
and where needed to add support for plugin added data tables - retaining any mappings to data in the core Coppermine tables affected by the merge.
<p>
data/plugin_data.php defines all 'known' plugins, and their impact on Gallery Merge.
Plugins can be added to the array defined there to:
<ul>
  <li>Eliminate 'Unknown Plugin' Warnings during Galery Merge</li>
  <li>Provide correct messages for Merge impact based on what the plugin does</li>
  <li>Provide link to script to support the merge if plugin defines it's own tables, and merge is required and supported.</li>
</ul>
Adding plugins to the data file even without support provided assists in providing proper impact assessment during Gallery Merge.
<p>
The information needed about a plugin is very simple:
<ul>
  <li>folder_name - the name of the main folder this plugin adds - no need to worry about sub-folders under it.</li>
  <li>alters_cpg_tables - TRUE or FALSE - If the plugin ALTERS the structure of CPG core tables, set to TRUE</li>
  <li>adds_tables - TRUE or FALSE - If the plugin adds it's own data tables, set to TRUE</li>
  <li>table_pattern - a pattern to match for this plugin's tables NOT including the CPG table prefix<br<
    ie - if the plugin creates tables cpg_cms and cpg_cms_config, then enter 'cms' as the pattern to match both names.</li>
  <li>standard_folders - TRUE or FALSE - if the plugin uses the standard location in the Plugins folder for its source, set to TRUE<br>
    some older mods add a folder to the main CPG root - this helps us correctly respond to a mismatch in folders during file compare.</li>
  <li>plugin_name - the name the plugin is known as in the CPG Plugins table (this may vary by language - and is used only for messages)</li>
  <li>merge_script - IF support is provided, the name of the script to include to provide the additional definitions/support<br>
    suggested name is merge_plugin_{pluginfoldername}</li>
  <li>pid_sql - If merge script translation will require picture (pid) information, provide SQL to generate set of PIDs that we care about...<br>
    Only required PIDs are mapped to conserve memory. in SQL use {cpg_table_prefix} to represent prefix...</li>
</ul>
Data can be added to 'plugins/gallery_merge/data/plugin_data.php'. Please let me know about plugins you research and add, so I can update the
distribution for the next person...
<p>&nbsp;<p>
EXAMPLE:
<pre>
  'folder_name' => array(                                                // (folder name this plugin adds)
     'alters_cpg_tables' => {TRUE|FALSE|unknown},                        // (changes CPG base tables STRUCTURES - adding columns, etc)
           'adds_tables' => {TRUE|FALSE|unknown},                        // (adds any new tables)
         'table_pattern' => '{pattern}',                                 // (patten to match for this plugins tables (that follows cpg table prefix)
      'standard_folders' => {TRUE|FALSE|unknown},                        // (FALSE if folder is outside of plugins directory - should only be older 'mods')
           'plugin_name' => '{name}',                                    // (name of plugin - may vary by language - only used in messages)
          'merge_script' => '{merge_plugin_{pluginfoldername}|needed|unknown|n/a}',    // (script to include if merge is supported for this table - .php suffix added of course)
                                 // ****** remaining fields only required if 'merge_script' is provided ******
                'pid_sql' => 'SELECT SQL to return list of PIDs')         // If merge script translation will require picture (pid) information, provide SQL to generate a result
                                                                          // set of PIDs that we care about...  Only required PIDs are mapped to conserve memory
                                                                          // in SQL use {cpg_table_prefix} to represent prefix...
</pre>

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Plugin Merge Scripts:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

For those plugins adding their own tables, the mapping and processing already part of Gallery Merge can be used to support these tables, and where needed - custom code can be provided -
but many will be able to be handled with just a little research and some parameter settings.
<p>
A skeleton is provided to clone for each supported plugin - start with 'plugins/gallery_merge/merge_plugin_skeleton.php' which contains an example of each type of process.<br>
Completed files should be named merge_plugin_{pluginfoldername}.php<p>
When to use this script:
<ul>
  <li>If a Plugin does NOT create it's own data tables, this script is not needed.</li>
  <li>This is intended to support merge of plugin defined tables - taking advantage of the mapping already done by gallery merge,
  and extending those capabilities to a plugin's tables.<br>
  In defining the support for Coppermine's core tables, a range of cases can be easily handled for plugin tables.</li>
</ul>
<p>&nbsp;<p>
Parameters:
<ul>
  <li>plugin_name - name as it appears in cpg_plugins table and data/plugin_data.php</li>
  <li>plugin_table_array - array with an entry for each table the plugin adds.
    <ul>
      <li>table_suffix - table name that follows the cpg table prefix</li>
      <li>process_type - Define the function to be use to process this table</li>
        <ul>
          <li>process_table - full mapping and insert support - requires additional fields below to be defined<br>
            if 'pre_merge_function' is specified, it will be called before normal processing<br>
            if 'post_merge_function' is specified, it will be called following normal processing</li>
          <li>compare_values - 'config' type table with name/value columns only - compare data and report missing fields or unmatched values<br>
            field names can be provided to match table definiton</li>
          <li>transient - data not required - could be logs, session info, or other data that doesn't need to carry forward</li>
          <li>static  - data doesn't change except with maint - compare row counts only</li>
          <li>unsupported - data not migrated - compare row counts only</li>
          <li>custom - invoke function(s) specified in 'pre_merge_function' and/or 'post_merge_function' to process this table</li>
        </ul>
      </li>
    </ul>
    Fields for 'compare_values'
    <ul>
      <li>compare_name_column - the name of the table column containing the variable names</li>
      <li>compare_value_column - the name of the table column containing the variable contents</li>
    </ul>
    Fields for 'process_table'
    <ul>
      <li>table_key - the key field name for this table - if there is no key field, spcify '*none*'</li>
      <li>order_by - by default, the table will be processed in key field sequence - if another order is required to see data in correct order, specify here<br>
        For example - in processing cpg_categories, we want to process parent categories before children - and not in order entered.<br>
        VALUES:
        <ul>
          <li>null - use default</li>
          <li>orderby = 'ORDER BY field1, field2, field3'</li>
        </ul>
      </li>
      <li>compare_fields - the field name(s) - comma separated -  to use to determine if row already exists in target - or if it will be inserted</li>
      <li>compare_type - type of compare to perform
        <ul>
          <li>UNIQUE = only insert unique records based on compare fields above.</li>
          <li>INSERT = insert all records - report duplicates based on compare fields above. (no unique indexes to stop duplicates)</li>
          <li>IGNORE = process table with INSERT IGNORE - no comparison needed, no duplicate processing needed</li>
        </ul>
        If merging of data in some form is needed - then special code will be required to handle.</li>
      <li>skip_keys - set keys/columns to bypass for insert (typically auto-increment fields) These will be excluded from the generated INSERT statements</li>
      <li>zero_keys - set keys/columns to 0 value on insert (typically data not yet available... to be updated later)</li>
      <li>map_values - array of column names to map - *IF* mapping is required for this table...<br>
        Mapping is ONLY required if later plugin tables need to translate data (like related key fields in this table) for INSERTs
        array contains column names to map.<br>
        Column name beginning with / is for doc purposes only - only source field (after / is stripped) is saved to make array more 'human readable'<br>
        The key field of the table will be mapped automatically - it does not need to be specified <br>
        EXAMPLE: array('/title', 'thumb')</li>
      <li>skip_keys_difference  - array of column names to bypass when comparing rows in source and target<br>
        Typically used to eliminate 'differences' messages for fields we know will be different... keys we know will change or be translated, last accessed timestamps, etc<br>
        EXAMPLE: array('aid', 'thumb')</li>
      <li>translations - array to request remapping of fields to new values - the workhorse of the process<br>
        Defined as: fieldname => table.keyvalue.field{.condition} to use
        <ul>
          <li>fieldname - column from this table to translate - or fieldname.suffix if providing conditions</li>
          <li>table - mapping table suffix to use</li>
          <li>keyvalue - key to mapping array to lookup</li>
          <li>field - field from mapping array to translate to. if prefixed with incr_ - adds the requested value rather than assigning...</li>
          <li>condition - {optional} specified as fieldname=value - only perform the requested mapping if condition field name = condition value.<br>
            used in cases where a translation depends on contents of another field..</li>
        </ul>
        MAPS AVAILABLE:<br>
        Each name including key represents a pair of entries to map from source to target
        <ul>
          <li>usergroups - key: 'group_id'
          <li>users      - key: 'user_id'
          <li>categories - key: 'cid'       - Additional Fields: 'pos', 'thumb', 'depth'
          <li>albums     - key: 'aid'       - Additional Fields: 'thumb'
          <li>pictures   - key: 'pid'<br>
            if mapping on pictures... to save memory, not all pid's are added to mapping array - only those which we care about..</li>
        </ul>
    </ul>
    Fields for 'custom' - and optional for 'process_table':<br>
    If none of the opions above will work for your plugin's tables - then you can provide your own functions to handle the data (process_type of 'custom')
    or combine the 'process_table' options with your own functions to 'tweak' the data. Ability to call a function either (or both) before or after the normal
    processing (custom can use either or both - nothing happens in between...)
    <ul>
      <li>pre_merge_function - name of function to call prior to executing normal merge processing
        can be existing cpg, gallery_merge plugin, or custom function defined in merge_plugin_{foldername}.php</li>
      <li>post_merge_function - name of function to call following execution of normal merge processing<br>
        can be existing cpg, gallery_merge plugin, or custom function defined in merge_plugin_{foldername}.php</li>
    </ul>
  </li>
</ul>
<p>&nbsp;<p>
EXAMPLE:
<pre>
   'table_suffix' => array(                                                        // table name that follows the cpg table prefix
            'process_type' => '{process_table|compare_values|transient|static|custom}',  // see detail above
                              // ****** following fields only required if 'process_type' = 'compare_values' ******
     'compare_name_column' => 'name',                                             // name of column containing the variable names
    'compare_value_column' => 'value',                                            // name of the column containing the variable setting
                              // ****** following fields only required if 'process_type' = 'process_table' or 'custom' ******
               'table_key' => 'aid',                                              // key field name
                 'orderby' => '';                                                 // order by key field is default to assist restart - override here if needed
          'compare_fields' => 'title';                                            // field(s) - comma separated - to match source to target (identify duplicates/inserts)
            'compare_type' => '';                                                 // type of compare: UNIQUE, IGNORE, MERGE
               'skip_keys' => array('aid');                                       // set keys/columns to bypass for insert (typically auto-increment fields)
               'zero_keys' => array('thumb');                                     // set keys/columns to 0 value on insert (typically data not yet available... to be updated later)
              'map_values' => array('/title', 'thumb');                           // set mapping values to set fields to build array for later processing
    'skip_keys_difference' => array('aid', 'thumb');                              // set keys to bypass for comparing like rows in source and target (like passwords...)
            'translations' => array('visibility' => 'usergroups.visibility.group_id', // <- translate 'visibility' field using usergroups mapping, visibility as key, and set to target group_id
                                    'owner' => 'users.owner.user_id',                 // <- translate 'owner' fied using users mapping, owner as key, and set to target user_id
                                    'pos' => 'categories.category.incr_subalbum_pos', // <- translate 'pos' field using categories mapping, category as key, and ADD the subalbum_pos to current pos value
                                    'conid.1' => 'categories.conid.cid.type=0',       // <- translate 'conid' field using categories mapping, conid as key, and set to target cid - ONLY IF type = 0
                                    'conid.2' => 'albums.conid.aid.type=1',           //    (the suffix following translate field (.1, .2, etc) are ignored - they can be any character or string to make array key unique)
                                    'conid.3' => 'pictures.conid.pid.type=2'), );  // set translations to be done... fieldname => table.keyvalue.field to use
                              // ****** following fields (at least one) only required if 'process_type' = 'custom' - Optional for 'process_type = 'process_table' ******
      'pre_merge_function' => ''                                                  // function to call before execution of merge script... (process types of 'process_table' and 'custom' only)
     'post_merge_function' => ''                                                  // function to call following execution of merge script... (process types of 'process_table' and 'custom' only)
</pre>

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
    </td>
  </tr>
  <tr>
    <td>

Congratulations again if you made it through all of this! And good luck merging galleries!!<br>
Your comments are welcome.<br>
I hope you find this useful.<br>
Greg (gmc on the CPG forum)
EOT;

if (!defined('IN_COPPERMINE')) {
  // allow direct display - add necessary html
  echo <<< EOT
          <table align="center" width="100%" cellspacing="1" cellpadding="0" class="maintable cpg_zebra">
       </div>
    </body>
  </html>
EOT;
}
?>